Package: OutSplice
Type: Package
Title: Comparison of Splicing Events between Tumor and Normal Samples
Version: 1.11.0
Authors@R: c(person("Joseph", "Bendik", role = "aut", comment = c(ORCID = "0000-0003-0877-5639")),
    person("Sandhya", "Kalavacherla", role = "aut", comment = c(ORCID = "0000-0003-0485-9042")),
    person("Michael", "Considine", role = "aut", comment = c(ORCID = "0000-0002-8666-4857")), 
    person("Bahman", "Afsari", role = "aut", comment = c(ORCID = "0000-0001-8717-7199")),
    person("Michael F.", "Ochs", role = "aut"), 
    person("Joseph", "Califano", role = "aut", comment = c(ORCID = "0000-0002-4715-6761")), 
    person("Daria A.", "Gaykalova", role = "aut", comment = c(ORCID = "0000-0001-5037-0147")), 
    person("Elana", "Fertig", role = "aut", comment = c(ORCID = "0000-0003-3204-342X")), 
    person("Theresa", "Guo", email = "twguo@health.ucsd.edu", role = c("cre", "aut"), comment = c(ORCID = "0000-0002-1689-3275")))
Description: An easy to use tool that can compare splicing events in
    tumor and normal tissue samples using either a user generated matrix, or
    data from The Cancer Genome Atlas (TCGA). This package generates a matrix of 
    splicing outliers that are significantly over or underexpressed in tumors
    samples compared to normal denoted by chromosome location. The package also
    will calculate the splicing burden in each tumor and characterize the 
    types of splicing events that occur.
Encoding: UTF-8
License: GPL-2
Depends: R(>= 4.3)
Imports: AnnotationDbi (>= 1.60.0), GenomicRanges (>= 1.49.0),
        GenomicFeatures (>= 1.50.2), IRanges (>= 2.32.0), org.Hs.eg.db
        (>= 3.16.0), TxDb.Hsapiens.UCSC.hg19.knownGene (>= 3.2.2),
        TxDb.Hsapiens.UCSC.hg38.knownGene (>= 3.16.0), S4Vectors (>=
        0.36.0)
Suggests: BiocStyle, knitr, rmarkdown, testthat
VignetteBuilder: knitr
biocViews: AlternativeSplicing, DifferentialExpression,
        DifferentialSplicing, GeneExpression, RNASeq, Software,
        VariantAnnotation
BugReports: https://github.com/GuoLabUCSD/OutSplice/issues
URL: https://github.com/GuoLabUCSD/OutSplice
RoxygenNote: 7.2.3
git_url: https://git.bioconductor.org/packages/OutSplice
git_branch: devel
git_last_commit: 14e6259
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-11-04
NeedsCompilation: no
Packaged: 2025-11-05 00:05:46 UTC; biocbuild
Author: Joseph Bendik [aut] (ORCID: <https://orcid.org/0000-0003-0877-5639>),
  Sandhya Kalavacherla [aut] (ORCID:
    <https://orcid.org/0000-0003-0485-9042>),
  Michael Considine [aut] (ORCID:
    <https://orcid.org/0000-0002-8666-4857>),
  Bahman Afsari [aut] (ORCID: <https://orcid.org/0000-0001-8717-7199>),
  Michael F. Ochs [aut],
  Joseph Califano [aut] (ORCID: <https://orcid.org/0000-0002-4715-6761>),
  Daria A. Gaykalova [aut] (ORCID:
    <https://orcid.org/0000-0001-5037-0147>),
  Elana Fertig [aut] (ORCID: <https://orcid.org/0000-0003-3204-342X>),
  Theresa Guo [cre, aut] (ORCID: <https://orcid.org/0000-0002-1689-3275>)
Maintainer: Theresa Guo <twguo@health.ucsd.edu>

# Function to Calculate Splicing Burden Based on the Number of Fisher Significant Events in Each Sample

calcBurden <- function(junc.Outliers, FisherAnalyses, p_value) {
    # Calculate Splicing Burden for Significant Events Over-Expressed in Tumors
    Over_Expressed_Junctions_Outlier_Calls <- as.data.frame(junc.Outliers$TumorOverExpression)
    row.names(Over_Expressed_Junctions_Outlier_Calls) <- sub("\\.", ":", rownames(Over_Expressed_Junctions_Outlier_Calls))
    row.names(Over_Expressed_Junctions_Outlier_Calls) <- sub("\\.", "-", rownames(Over_Expressed_Junctions_Outlier_Calls))

    OE_pvalue <- subset(FisherAnalyses, select = FisherP2)
    Over_Expressed_Junctions_Outlier_Calls <- merge(OE_pvalue,
        Over_Expressed_Junctions_Outlier_Calls,
        by = "row.names", all.x = TRUE
    )
    rownames(Over_Expressed_Junctions_Outlier_Calls) <- Over_Expressed_Junctions_Outlier_Calls$Row.names
    Over_Expressed_Junctions_Outlier_Calls <- subset(Over_Expressed_Junctions_Outlier_Calls, select = -Row.names)
    Over_Expressed_Junctions_Outlier_Calls <- na.omit(Over_Expressed_Junctions_Outlier_Calls)
    Over_Expressed_Junctions_Outlier_Calls <- subset(
        Over_Expressed_Junctions_Outlier_Calls,
        Over_Expressed_Junctions_Outlier_Calls$FisherP2 < p_value
    )
    Over_Expressed_Junctions_Outlier_Calls <- subset(Over_Expressed_Junctions_Outlier_Calls, select = -FisherP2)

    OutlierNumberOver <- colSums(Over_Expressed_Junctions_Outlier_Calls)
    all_oe_results_df <- data.frame(OutlierNumberOver)

    # Calculate Splicing Burden for Significant Events Under-Expressed in Tumors
    Under_Expressed_Junctions_Outlier_Calls <- as.data.frame(junc.Outliers$TumorUnderExpression)
    row.names(Under_Expressed_Junctions_Outlier_Calls) <- sub(
        "\\.", ":",
        rownames(Under_Expressed_Junctions_Outlier_Calls)
    )
    row.names(Under_Expressed_Junctions_Outlier_Calls) <- sub(
        "\\.", "-",
        rownames(Under_Expressed_Junctions_Outlier_Calls)
    )

    UE_pvalue <- subset(FisherAnalyses, select = FisherP1)
    Under_Expressed_Junctions_Outlier_Calls <- merge(UE_pvalue,
        Under_Expressed_Junctions_Outlier_Calls,
        by = "row.names", all.x = TRUE
    )
    rownames(Under_Expressed_Junctions_Outlier_Calls) <- Under_Expressed_Junctions_Outlier_Calls$Row.names
    Under_Expressed_Junctions_Outlier_Calls <- subset(Under_Expressed_Junctions_Outlier_Calls, select = -Row.names)
    Under_Expressed_Junctions_Outlier_Calls <- na.omit(Under_Expressed_Junctions_Outlier_Calls)
    Under_Expressed_Junctions_Outlier_Calls <- subset(
        Under_Expressed_Junctions_Outlier_Calls,
        Under_Expressed_Junctions_Outlier_Calls$FisherP1 < p_value
    )
    Under_Expressed_Junctions_Outlier_Calls <- subset(Under_Expressed_Junctions_Outlier_Calls, select = -FisherP1)

    OutlierNumberUnder <- colSums(Under_Expressed_Junctions_Outlier_Calls)
    all_ue_results_df <- data.frame(OutlierNumberUnder)

    # Total Splicing Burden as the sum of Over + Under Expressed Events
    total_results <- transform(merge(all_oe_results_df, all_ue_results_df, by = 0, all = TRUE),
        TotalOutliers = OutlierNumberOver + OutlierNumberUnder
    )
    rownames(total_results) <- total_results$Row.names
    convert_total <- subset(total_results, select = c(-OutlierNumberOver, -OutlierNumberUnder, -Row.names))
    total_burden <- as.data.frame(convert_total)

    splice_burden <- cbind(all_oe_results_df, all_ue_results_df, total_burden)

    return(splice_burden)
}

#' OutSplice package overview
#'
#' An easy to use tool that can compare splicing events in tumor and normal tissue
#' samples using either a user generated matrix, or data from The Cancer Genome Atlas (TCGA).
#' This package generates a matrix of splicing outliers that are significantly
#' over or underexpressed in tumors samples compared to normal denoted by chromosome location.
#' The package also will calculate the splicing burden in each tumor, characterize
#' the types of splicing events that occur, and allows the user to create waterfall
#' plots of event expression.
#'
#' Below are the available functions provided by OutSplice:
#' \itemize{
#'     \item \code{\link{outspliceAnalysis}}
#'     \item \code{\link{outspliceTCGA}}
#'     \item \code{\link{plotJunctionData}}
#' }
#' @return Please see the man pages for each function.
#'
#' @name OutSplice
#'
#' @import GenomicRanges
#' @importFrom GenomicFeatures genes exons
#' @importFrom IRanges IRanges overlapsAny
#' @importFrom org.Hs.eg.db org.Hs.eg.db
#' @importFrom TxDb.Hsapiens.UCSC.hg19.knownGene TxDb.Hsapiens.UCSC.hg19.knownGene
#' @importFrom TxDb.Hsapiens.UCSC.hg38.knownGene TxDb.Hsapiens.UCSC.hg38.knownGene
#' @importFrom S4Vectors Rle subjectHits queryHits
#' @importFrom AnnotationDbi select
NULL

#  Outlier Gene Set Analysis
#
#  cite with PMID: 24277953
#  Ochs et al IEEE/ACM Trans Comput Biol Bioinform 2013
#
#  outCallRank - counts outliers by the Ghosh method from
#         J Biopharm Stat 20, 193, 2010
#      and generates list object with all outliers noted,
#      modified from Yingying Wei's original
#
#
# Inputs: dataList - set of data which includes phenotype information
#         thres - alpha value
#         tail - vector equal to number of matrices with
#                  values 'left' or 'right' for where to find
#                  outliers
#         corr = whether to correct for normal outliers
#         offsets = vector equal to number of matrices which
#                    sets minimum value relative to normal to
#                    call outlier (corrected rank only)
#         names - vector equal to number of matrices to name
#                 molecular type of data (e.g., 'CNV')
#
#  Output: a list with all specific outlier calls for each molecular
#          type in each case sample
#
#  v 1.0 - Michael Ochs, TCNJ, 15 Jan 2014
#  v 1.1 - Joseph Bendik, UCSD, 07 Mar 2023 changed sapply to vapply, changed 1:... to seq_len(n) or seq_along(x)


outCallRank <- function(dataList, thres = 0.05, tail = "right", corr = FALSE, offsets = NULL, names = NULL) {
    if (is.null(names)) {
        names <- vector(length = length(dataList), mode = "character")
        for (d in seq_along(dataList)) {
            names[d] <- paste("Data", d)
        }
    }
    temp <- dataList[[1]]
    temp <- temp[[1]]
    nG <- dim(temp)[1]
    outList <- list()

    if (!corr) {
        offsets <- rep(0.0, dim(temp)[2])
    } else if (is.null(offsets)) {
        message("No Offsets Set with Correction Requested")
        return()
    }

    outP <- matrix(nrow = nG, ncol = 2)
    outCount <- rep(0, nG)

    for (d in seq_along(dataList)) {
        data <- dataList[[d]]
        phenotype <- data[[2]]
        data <- data[[1]]
        nS <- length(phenotype)
        thisTail <- tail[d]

        adjust <- offsets[d]
        nData <- data[, phenotype == 0]
        tData <- data[, phenotype == 1]
        nT <- dim(tData)[2]

        # generate empicical pValues as the
        # number of sum(normals{<,>}tumor)/nN
        empirP <- matrix(nrow = nG, ncol = nT)
        if (thisTail == "right") {
            for (i in seq_len(nG)) {
                tumor <- tData[i, ]
                baseline <- nData[i, ]
                result <- vapply(seq_along(tumor), function(j) {
                    sum((baseline + adjust) > tumor[j])
                }, integer(1))
                empirP[i, ] <- result / length(baseline)
            }
        } else if (thisTail == "left") {
            for (i in seq_len(nG)) {
                tumor <- tData[i, ]
                baseline <- nData[i, ]
                result <- vapply(seq_along(tumor), function(j) {
                    sum((baseline - adjust) < tumor[j])
                }, integer(1))
                empirP[i, ] <- result / length(baseline)
            }
        }
        empirP <- empirP < thres
        rownames(empirP) <- rownames(data)
        colnames(empirP) <- colnames(tData)
        outList[[d]] <- empirP
    }
    names(outList) <- names
    return(outList)
}

# Shared Sub FUnction for outSpliceAnalysis and outSpliceTCGA for overall data processing

processMatrices1 <- function(pheno, all.junc, all.samples, all.gene_expr, rawcounts, filterSex, annotation, TxDb) {
    # subset only primary tumor 01 or normal 11
    all.samples <- names(pheno)
    all.junc <- all.junc[, all.samples]
    all.gene_expr <- all.gene_expr[, all.samples]
    rawcounts <- rawcounts[, all.samples]
    pheno <- pheno[all.samples]

    ## change from char to numeric
    n <- vapply(all.gene_expr, as.numeric, numeric(nrow(all.gene_expr)))
    rownames(n) <- rownames(all.gene_expr)
    all.gene_expr <- n
    n <- vapply(all.junc, as.numeric, numeric(nrow(all.junc)))
    rownames(n) <- rownames(all.junc)
    all.junc <- n
    remove(n)

    ## normalize Junctions to get RPM
    junc.RPM <- getRPM(rawcounts, all.junc, all.samples)

    ###### NEW FILTER: See if tumors have any outliers ###########################
    ## PHENO should have 'Normal' or 'Tumor' calls where Tumor ==1, Normal ==0, and names of each sample associated
    PHENO <- pheno == "Tumor"
    PHENO <- as.numeric(PHENO)
    names(PHENO) <- names(pheno)

    message("run the ogsa function for pre filtering")
    ## get function
    test2 <- dotheogsa(Sample.data = junc.RPM, PHENO = PHENO, offsets = 0.1)
    has.outliers <- test2[, "Num_UE_Outliers"] > 1 | test2[, "Num_OE_Outliers"] > 1
    junc.RPM <- junc.RPM[has.outliers, ]

    ### Filter all genes on the X and Y chromosomes

    if (filterSex) {
        junc.RPM <- junc.RPM[grep("chr[XY]", row.names(junc.RPM), value = TRUE, invert = TRUE), ]
    }
    ##############################################################
    message("get the genomic information for all the junctions")

    geneAnnot <- getGenomicInfo(junc.RPM, annotation, TxDb)

    #Filter events without event type
    geneAnnot <- geneAnnot[apply(cbind(
        geneAnnot$deletions, geneAnnot$insertions,
        geneAnnot$skipping
    ), 1, any), ]

    junc.RPM <- junc.RPM[names(geneAnnot), ]

    ##################################################################
    message("remove all that map to 'NA' no gene name, and assign gene expression from gene_expr")
    junc.RPM <- junc.RPM[!is.na(geneAnnot$SYMBOL), ]

    geneAnnot <- geneAnnot[row.names(junc.RPM), ]

    ## remove row names for unknown genes containing "?" unknown genes

    all.gene_expr <- all.gene_expr[!grepl("\\?", row.names(all.gene_expr)), ]

    os_data <- list(
        "junc.RPM" = junc.RPM, "geneAnnot" = geneAnnot,
        "all.gene_expr" = all.gene_expr, "PHENO" = PHENO, "pheno" = pheno
    )

    return(os_data)
}

# Second Shared Sub Function for outSpliceAnalysis and outSpliceTCGA for overall data processing

processMatrices2 <- function(junc.RPM, junctionGenegene_expr, PHENO, offsets_value,
                             correction_setting, p_value, pheno, geneAnnot, saveOutput, output_file_prefix, dir, date) {
    # remove junctions without gene expression
    junc.RPM <- junc.RPM[row.names(junctionGenegene_expr), ]

    message("subset removing any genes without normalization")
    junc.RPM2 <- junc.RPM[!(apply(junctionGenegene_expr, 1, sum)) == 0, ]
    dim(junc.RPM2)
    # ## filters junctions
    junc.RPM.original <- junc.RPM
    junc.RPM <- junc.RPM2

    message("Perform normalization using gene_expr values")

    junc.RPM.norm <- normalizeJunctions(junc.RPM2, junctionGenegene_expr)

    ### perform outlier analysis with OGSA
    ############### Use OGSA for outlier ranking #################

    message("run the ogsa function")

    FisherAnalyses <- dotheogsa(
        Sample.data = junc.RPM.norm, PHENO = PHENO,
        offsets = offsets_value, Fisher = TRUE, correction = correction_setting
    )
    ## use default offset=0.001 for normalized data
    # create lists of top genes

    ## Use Fisher to subset candidates that have Fisher test p value <0.05, or cutoff can be adjusted
    ## Underexpression in tumors
    toplist10 <- subset_underEx(FisherAnalyses, p_value)

    ## Overexpression in tumors
    toplist90 <- subset_overEx(FisherAnalyses, p_value)

    junctions <- c(rownames(toplist90), rownames(toplist10))
    pvalues <- c(toplist90$FisherP2, toplist10$FisherP1)

    ### get outier calls##
    junc.Outliers <- dotheogsa(
        Sample.data = junc.RPM.norm, PHENO = PHENO,
        offsets = offsets_value, Fisher = TRUE, correction = correction_setting, outliers = TRUE
    )

    ## median of normal expression within the normalized data
    NORM.gene_expr.norm <- apply(junc.RPM.norm[, pheno == "Normal"], 1, median)

    ## aggregate the data
    gene_expr <- junctionGenegene_expr
    junc.RPM.norm <- junc.RPM.norm

    geneAnnotations <- geneAnnot
    geneAnnot <- geneAnnot[junctions]
    ASE.type <- cbind(geneAnnot$skipping, geneAnnot$insertions, geneAnnot$deletions)
    colnames(ASE.type) <- c("skipping", "insertions", "deletions")
    row.names(ASE.type) <- junctions

    ## calculate splicing burden
    splice_burden <- calcBurden(junc.Outliers, FisherAnalyses, p_value)

    ## optionally save output if specified
    if (saveOutput) {
        saveResults(
            junc.RPM, gene_expr, junc.RPM.norm, pvalues, pheno, FisherAnalyses,
            geneAnnotations, ASE.type, NORM.gene_expr.norm, junc.Outliers,
            splice_burden, output_file_prefix, date, dir
        )
    }

    ## create return value
    final_results <- list(
        "junc.RPM" = junc.RPM, "gene_expr" = gene_expr, "junc.RPM.norm" = junc.RPM.norm,
        "pvalues" = pvalues, "pheno" = pheno, "FisherAnalyses" = FisherAnalyses,
        "geneAnnotations" = geneAnnotations, "ASE.type" = ASE.type,
        "NORM.gene_expr.norm" = NORM.gene_expr.norm, "junc.Outliers" = junc.Outliers,
        "splice_burden" = splice_burden
    )
    return(final_results)
}

## analyze junctions from RNA based sequencing data

#' Analyzes differential splicing events between tumor and normal samples.
#'
#' @title Alternative Splicing Analyses
#' @param junction A character string giving the path to a tab separated text file with raw junction counts. One column should include all of the junctions to be looked at by OutSplice (Ex: chr1: 1-100). Each proceeding column is a sample with the raw count information for each corresponding junction. The header row contains the name of the junction column, and the names of the samples.
#' @param gene_expr A character string giving the path to a tab separated file with normalized gene expression data. One column should include all of the entrez ids for each gene, and each proceeding column should be a sample with the normalized expression values for each gene. The file header row contains the name of the entrez id column, and the names of the samples.
#' @param rawcounts A character string giving the path to a tab separated text file with the reads per million counts for each sample. This file can either include a row with the total counts per sample, or multiple rows with raw counts per gene per sample that will be summed automatically by OutSplice. One of the columns should include the user defined row names and the subsequent columns are the sample's rawcount information. The header row contains the name of the row names column and the names of the samples.
#' @param sample_labels A character string giving the path to a tab separated text file with a matrix of tumor and normal labels (T/F) for each sample. One of the columns should include the names of the samples, and the other column should include "T" for tumors and "F" for normals. The header row contains user defined column names.
#' @param saveOutput A boolean representing whether or not to save the results to an R data file and tab separated files. Default is FALSE. Optional.
#' @param output_file_prefix A character string giving the name of the prefix the user would like to use for the output data file. Default is NULL. Optional.
#' @param dir A character string giving the path to the directory the user would like to save output to. Default is NULL. Optional.
#' @param filterSex A boolean representing whether or not to include junctions found on the sex chromosomes. Default is TRUE. Optional.
#' @param annotation A connection or a character string giving the name of the Bioconductor library the user would like to use containing the genome wide annotation. Default is "org.Hs.eg.db". Optional.
#' @param TxDb A character string giving the name of the Bioconductor library the user would like to use that will expose the annotation database as a TxDb object. Default is "TxDb.Hsapiens.UCSC.hg38.knownGene". Optional.
#' @param offsets_value The minimum expression value needed to call an event an outlier after normalizing event expression with gene expression. Default is 0.00001. Optional.
#' @param correction_setting Option to designate how to correct significance. The available options are: "holm", "hochberg", "hommel", "bonferroni", "BH", "BY", "fdr", and "none". Default is "fdr". Optional.
#' @param p_value Set the alpha value for the significance threshold. Default is 0.05. Optional.
#' @param use_junc_col An integer indicating which column in the junction matrix contains the junction regions in your matrices. Default is 1. Optional
#' @param use_gene_col An integer indicating which column in the gene_expr matrix contains the entrez ids of your genes. Default is 1. Optional
#' @param use_rc_col An integer indicating which column in the rawcounts matrix contains the row names. Default is 1. Optional
#' @param use_labels_col An integer indicating which column in the sample_labels matrix contains the sample names. Default is 1. Optional
#' @return A list containing the below data.
#' \itemize{
#'     \item FisherAnalyses: Data Frame of junction events containing the number of under/over-expressed outliers in the tumor group (Num_UE_Outliers/Num_OE_Outliers), the Fisher p-value for under/over-expressed events (FisherP1/FisherP2), and a ranking of the under/over expressed events (UE_Rank/OE_Rank)
#'     \item ASE.type: significant junction events labeled by type (skipping, insertion, or deletion)
#'     \item geneAnnotations: object containing gene names corresponding to each junction region
#'     \item junc.Outliers: list containing the logical matrices TumorOverExpression and TumorUnderExpression. "True" indicates an over-expressed event in TumorOverExpression, or an under-expressed event in TumorUnderExpression.
#'     \item junc.RPM: junction counts in reads per million following a division of the junction counts input by the total rawcounts for each sample
#'     \item junc.RPM.norm: junction counts normalized by each event's total gene expression value
#'     \item gene_expr: gene expression values for each junction event
#'     \item splice_burden: matrix containing the number of Fisher-P significant over-expressed, under-expressed, and total number of outliers per sample
#'     \item NORM.gene_expr.norm: Median of junction data normalized by gene expression for normal samples only (Used for Junction Plotting Only)
#'     \item pheno: Phenotypes of Samples (Tumor or Normal)
#'     \item pvalues: Junction Fisher P-values
#' }
#' @examples
#' junction <- system.file("extdata", "HNSC_junctions.txt.gz", package = "OutSplice")
#' gene_expr <- system.file("extdata", "HNSC_genes_normalized.txt.gz", package = "OutSplice")
#' rawcounts <- system.file("extdata", "Total_Rawcounts.txt", package = "OutSplice")
#' sample_labels <- system.file("extdata", "HNSC_pheno_table.txt", package = "OutSplice")
#' output_file_prefix <- "OutSplice_Example"
#' TxDb_hg19 <- "TxDb.Hsapiens.UCSC.hg19.knownGene"
#' dir <- paste0(tempdir(), "/")
#' results <- outspliceAnalysis(junction, gene_expr, rawcounts, sample_labels, saveOutput = TRUE, output_file_prefix, dir, filterSex = TRUE, annotation = "org.Hs.eg.db", TxDb = TxDb_hg19, offsets_value = 0.00001, correction_setting = "fdr", p_value = 0.05)
#' message("Output is located at: ", dir)
#' @references
#' Broad Institute TCGA Genome Data Analysis Center (2016): Firehose stddata__2016_01_28 run. Broad Institute of MIT and Harvard. doi:10.7908/C11G0KM9
#'
#' Cancer Genome Atlas Network. Comprehensive genomic characterization of head and neck squamous cell carcinomas. Nature. 2015 Jan 29;517(7536):576-82. doi: 10.1038/nature14129. PMID: 25631445; PMCID: PMC4311405.
#'
#' Guo T, Sakai A, Afsari B, Considine M, Danilova L, Favorov AV, Yegnasubramanian S, Kelley DZ, Flam E, Ha PK, Khan Z, Wheelan SJ, Gutkind JS, Fertig EJ, Gaykalova DA, Califano J. A Novel Functional Splice Variant of AKT3 Defined by Analysis of Alternative Splice Expression in HPV-Positive Oropharyngeal Cancers. Cancer Res. 2017 Oct 1;77(19):5248-5258. doi: 10.1158/0008-5472.CAN-16-3106. Epub 2017 Jul 21. PMID: 28733453; PMCID: PMC6042297.
#'
#' Liu C, Guo T, Sakai A, Ren S, Fukusumi T, Ando M, Sadat S, Saito Y, Califano JA. A novel splice variant of LOXL2 promotes progression of human papillomavirus-negative head and neck squamous cell carcinoma. Cancer. 2020 Feb 15;126(4):737-748. doi: 10.1002/cncr.32610. Epub 2019 Nov 13. PMID: 31721164.
#'
#' Liu C, Guo T, Xu G, Sakai A, Ren S, Fukusumi T, Ando M, Sadat S, Saito Y, Khan Z, Fisch KM, Califano J. Characterization of Alternative Splicing Events in HPV-Negative Head and Neck Squamous Cell Carcinoma Identifies an Oncogenic DOCK5 Variant. Clin Cancer Res. 2018 Oct 15;24(20):5123-5132. doi: 10.1158/1078-0432.CCR-18-0752. Epub 2018 Jun 26. PMID: 29945995; PMCID: PMC6440699.
#'
#' M. F. Ochs, J. E. Farrar, M. Considine, Y. Wei, S. Meshinchi, and R. J. Arceci. Outlier analysis and top scoring pair for integrated data analysis and biomarker discovery. IEEE/ACM Trans Comput Biol Bioinform, 11: 520-32, 2014. PMCID: PMC4156935
#' @export
outspliceAnalysis <- function(junction, gene_expr, rawcounts, sample_labels,
                              saveOutput = FALSE, output_file_prefix = NULL,
                              dir = NULL, filterSex = TRUE, annotation = "org.Hs.eg.db",
                              TxDb = "TxDb.Hsapiens.UCSC.hg38.knownGene",
                              offsets_value = 0.00001, correction_setting = "fdr", p_value = 0.05,
                              use_junc_col = 1, use_gene_col = 1, use_rc_col = 1, use_labels_col = 1) {
    checkOSArgs(junction, gene_expr, rawcounts)
    stopifnot("Sample Labels File does not exist. Check path to file." = file.exists(sample_labels))

    if (saveOutput) {
        checkDirArgs(output_file_prefix, dir)
    }

    date <- Sys.Date()

    ## this is non-log transformed data and includes pheno (RAW, in RPM)
    message("Loading data")
    all.junc <- read.table(file = junction, sep = "\t", header = TRUE, stringsAsFactors = FALSE)
    all.gene_expr <- read.table(file = gene_expr, header = TRUE, row.names = use_gene_col, sep = "\t")
    rawcounts <- read.table(
        file = rawcounts, sep = "\t", header = TRUE,
        row.names = use_rc_col, stringsAsFactors = FALSE
    )
    samps.labels <- read.table(
        file = sample_labels, sep = "\t", row.names = use_labels_col,
        header = TRUE, stringsAsFactors = FALSE
    )

    colnames(rawcounts) <- gsub("\\.", "-", colnames(rawcounts))

    all.samples <- colnames(all.junc)

    all.samples <- gsub("\\.", "-", all.samples)
    junction.names <- all.junc[, use_junc_col]
    # remove duplicates
    all.junc <- all.junc[!duplicated(junction.names), ]
    junction.names <- all.junc[, use_junc_col]

    rownames(all.junc) <- junction.names
    colnames(all.junc) <- all.samples

    # remove first column
    all.junc <- all.junc[, -use_junc_col]

    expression.samples <- gsub("\\.", "-", colnames(all.gene_expr))
    colnames(all.gene_expr) <- expression.samples

    # Order Columns by Name
    samps.labels_df <- as.data.frame((t(samps.labels)))
    samps.labels_df <- samps.labels_df[, order(colnames(samps.labels_df))]

    all.junc <- all.junc[, order(colnames(all.junc))]

    all.gene_expr <- all.gene_expr[, order(colnames(all.gene_expr))]

    rawcounts <- rawcounts[, order(colnames(rawcounts))]

    # Get Vector of labels
    samps.labels <- (t(samps.labels))
    samps.labels <- samps.labels[, order(colnames(samps.labels))]

    # infer phenotype from sample names
    all.samples <- intersect(colnames(all.junc), colnames(all.gene_expr))
    all.samples <- intersect(all.samples, colnames(rawcounts))
    all.samples <- intersect(all.samples, colnames(samps.labels_df))

    pheno <- samps.labels
    names(pheno) <- all.samples
    # include only tumor or normal
    pheno <- pheno[pheno == TRUE | pheno == FALSE]
    pheno[pheno == TRUE] <- "Tumor"
    pheno[pheno == FALSE] <- "Normal"
    message(paste0(capture.output(table(pheno)), collapse = "\n"))
    #
    if (sum(pheno == "Normal") < 10) {
        stop("Too few normal samples")
    }
    if (sum(pheno == "Tumor") < 2)  {
        stop("Too few tumor samples")
    }

    ## Run Data Processing Function
    data <- processMatrices1(
        pheno, all.junc, all.samples, all.gene_expr, rawcounts,
        filterSex, annotation, TxDb
    )

    ## get gene IDs
    gene_exprEntrezID <- row.names(data$all.gene_expr)

    message("align with gene_expr data")

    junctionGenegene_expr <- getExpressions(data$geneAnnot, data$all.gene_expr, gene_exprEntrezID)

    ## Run Second Data Processing Function

    final_results <- processMatrices2(
        data$junc.RPM, junctionGenegene_expr, data$PHENO,
        offsets_value, correction_setting, p_value,
        data$pheno, data$geneAnnot, saveOutput, output_file_prefix, dir, date
    )

    return(final_results)
}

test_that("outsplice function runs and the number of outliers at example ECM1 junction is correct", {
    junction <- system.file("extdata", "HNSC_junctions.txt.gz", package = "OutSplice")
    gene_expr <- system.file("extdata", "HNSC_genes_normalized.txt.gz", package = "OutSplice")
    rawcounts <- system.file("extdata", "Total_Rawcounts.txt", package = "OutSplice")
    sample_labels <- system.file("extdata", "HNSC_pheno_table.txt", package = "OutSplice")
    dir <- paste0(tempdir(), "/")
    results <- outspliceAnalysis(junction, gene_expr, rawcounts, sample_labels, saveOutput = TRUE, output_file_prefix = "outsplice_unit_test", dir = dir, filterSex = TRUE, annotation = "org.Hs.eg.db", TxDb = "TxDb.Hsapiens.UCSC.hg19.knownGene", offsets_value = 0.00001, correction_setting = "fdr", p_value = 0.05)
    expect_no_error(results)
    expect_equal(unname(unlist(results$FisherAnalyses["chr1:150483674-150483933", "Num_OE_Outliers"])), 28)
})

# -- Function: OGSA for ranking fusions or junctions within the data###
## First version Nov 14,2014
## This function ranks samples based on the number of outliers present in tumor samples, and then by median of expression in tumors
## Add Fisher test to compare outlier calls in tumors and normals. December 17, 2014
## Add FDR correction as a parameter, April 17, 2014.  default, no correction.
# Otherwise corection==name of correction method, i.e. "holm", "hochberg", "hommel", "bonferroni", "BH", "BY", "fdr", "none"
# if getting outlier calls for output, outliers=T

dotheogsa <- function(Sample.data, PHENO, offsets = 0.001, Fisher = FALSE, correction = NA, outliers = FALSE)
## PHENO should have 'Normal' or 'Tumor' calls where Tumor ==1, Normal ==0, and names of each sample associated
{
    ## Define tumors and normals

    ### run outlier analysis for true distribution of tumors and normals

    if (Fisher == TRUE) {
        ## Initialize a matrix so program will call outliers in normals
        Sample.data.normals <- Sample.data[, PHENO == 0]
        no.of.normals <- sum(PHENO == 0)
        no.of.tumors <- sum(PHENO == 1)
        # repeat the normal samples so they will be tested as if they are a set of tumors
        Sample.data.normals <- cbind(Sample.data.normals, Sample.data.normals)
        PHENO.N <- PHENO[PHENO == 0]
        PHENO.N[PHENO.N == 0] <- 1
        PHENO2 <- c(PHENO[PHENO == 0], PHENO.N)
        dataExprs2 <- list(list(Sample.data.normals, PHENO2))
    }

    PHENO <- t(data.frame(PHENO))

    dataExprs <- list(list(Sample.data, PHENO))


    ## get expression of junction in tumors
    Sample.data.tumor <- Sample.data[, PHENO == 1] ## subset to expression in tumors only
    SampleTotals <- apply(Sample.data.tumor, 1, median) ## median of tumor expression

    ## Rank first by number of outliers identified.  Then if there are samples with the same outlier, order by the median of tumor expression

    ## smallest to largest, copa10 (underexpression in tumors)
    ## now do the outlier ranking with tail='left' for if tumor is less than normal
    outRankExprs1 <- outCallRank(dataExprs, names = c("Expr"), tail = "left", corr = TRUE, offsets = offsets)$Expr
    ### get number of outliers in the tumor group
    Num_UE_Outliers <- apply(outRankExprs1, 1, sum)
    SampleTotals1 <- order(SampleTotals, decreasing = TRUE)
    ## ranks first by # of outliers, then by smaller level of tumor expression
    UE_Rank <- order(Num_UE_Outliers, SampleTotals1, decreasing = TRUE)

    if (Fisher == TRUE) {
        ## Calculate outliers in normal tissue
        outRankExprs1.normals <- outCallRank(dataExprs2,
            names = c("Expr"), tail = "left",
            corr = TRUE, offsets = offsets
        )$Expr
        outRankNormal1 <- apply(outRankExprs1.normals, 1, sum)

        ## Perform Fisher's exact test
        FisherP1 <- matrix(NA,
            nrow = nrow(Sample.data), ncol = 1,
            dimnames = list(c(row.names(Sample.data)), "FisherP1")
        )

        for (i in seq_len(nrow(Sample.data))) {
            ## Make contingency tables
            test <- matrix(
                c(
                    outRankNormal1[i], no.of.normals - outRankNormal1[i],
                    Num_UE_Outliers[i], no.of.tumors - Num_UE_Outliers[i]
                ),
                nrow = 2, ncol = 2, dimnames = list(c("outliers", "rest"), c("Normal", "Tumor"))
            )
            ## Get p-value from fisher test.  Will do two sided test
            FisherP1[i] <- fisher.test(test, alternative = "two.sided")$p.value
        }
    }

    ###### largest to smallest, copa90 (overexpression in tumors)#####################
    outRankExprs2 <- outCallRank(dataExprs,
        names = c("Expr"), tail = "right",
        corr = TRUE, offsets = offsets
    )$Expr
    Num_OE_Outliers <- apply(outRankExprs2, 1, sum)
    OE_Rank <- order(Num_OE_Outliers, SampleTotals, decreasing = TRUE)


    if (Fisher == TRUE) {
        ## Calculate outliers in normal tissue
        outRankExprs2.normals <- outCallRank(dataExprs2,
            names = c("Expr"), tail = "right",
            corr = TRUE, offsets = offsets
        )$Expr
        outRankNormal2 <- apply(outRankExprs2.normals, 1, sum)

        ## Perform Fisher's exact test
        FisherP2 <- matrix(NA,
            nrow = nrow(Sample.data), ncol = 1,
            dimnames = list(c(row.names(Sample.data)), "FisherP2")
        )

        for (i in seq_len(nrow(Sample.data))) {
            ## Make contingency tables
            test <- matrix(
                c(
                    outRankNormal2[i], no.of.normals - outRankNormal2[i],
                    Num_OE_Outliers[i], no.of.tumors - Num_OE_Outliers[i]
                ),
                nrow = 2, ncol = 2, dimnames = list(c("outliers", "rest"), c("Normal", "Tumor"))
            )
            ## Get p-value from fisher test.  Will do two sided test
            FisherP2[i] <- fisher.test(test, alternative = "two.sided")$p.value
        }
    }

    ## output data for the function!
    if (outliers == FALSE) {
        if (Fisher == TRUE) {
            ## add FDR correction
            if (!is.na(correction)) {
                FisherP1 <- p.adjust(FisherP1, method = correction)
                FisherP2 <- p.adjust(FisherP2, method = correction)
            }
            RankingData_UE <- cbind(Num_UE_Outliers, UE_Rank, FisherP1)
            RankingData_OE <- cbind(Num_OE_Outliers, OE_Rank, FisherP2)
            RankingData_UE <- as.data.frame(RankingData_UE)
            RankingData_OE <- as.data.frame(RankingData_OE)
            RankingData_UE <- RankingData_UE[RankingData_UE$UE_Rank, ]
            RankingData_OE <- RankingData_OE[RankingData_OE$OE_Rank, ]
            RankingData_UE$UE_Rank <- c(seq_len(nrow(RankingData_UE)))
            RankingData_OE$OE_Rank <- c(seq_len(nrow(RankingData_OE)))
            RankingData <- merge(RankingData_UE, RankingData_OE, by = "row.names", all = TRUE)
            rownames(RankingData) <- RankingData$Row.names
            RankingData <- subset(RankingData, select = -Row.names)
            return(RankingData)
        } else {
            RankingData <- cbind(Num_UE_Outliers, UE_Rank, Num_OE_Outliers, OE_Rank)
            return(RankingData)
        }
    } else {
        OutlierCalls <- list("TumorUnderExpression" = outRankExprs1, "TumorOverExpression" = outRankExprs2)
        return(OutlierCalls)
    }
}

# Function to subset significant under-expressed junction events

subset_underEx <- function(FisherAnalyses, p_value) {
    toplist10 <- FisherAnalyses[order(FisherAnalyses$UE_Rank), ]
    if (sum(toplist10[, "FisherP1"] < p_value) > 0) {
        toplist10 <- toplist10[toplist10[, "FisherP1"] < p_value, ]
        toplist10 <- subset(toplist10, select = FisherP1)
    } else {
        toplist10 <- NULL
    }
    return(toplist10)
}

# Function to validate function arguments

checkOSArgs <- function(junction, gene_expr, rawcounts) {
    stopifnot("Junction File does not exist. Check path to file." = file.exists(junction))
    stopifnot("Expression File does not exist. Check path to file." = file.exists(gene_expr))
    stopifnot("Rawcounts File does not exist. Check path to file." = file.exists(rawcounts))
}

checkDirArgs <- function(output_file_prefix, dir) {
    stopifnot("Output File Prefix is not a string. Check quotations." = is.character(output_file_prefix))
    stopifnot("Directory is not provided or not a string." = is.character(dir))
    stopifnot("Path to Output Directory should end with a '/'" = endsWith(dir, "/"))
    stopifnot("Output Directory does not exist" = dir.exists(dir))
}

# Optional Funciton to save output to tab separated text files

saveResults <- function(junc.RPM, gene_expr, junc.RPM.norm, pvalues, pheno, FisherAnalyses,
                        geneAnnotations, ASE.type, NORM.gene_expr.norm, junc.Outliers,
                        splice_burden, output_file_prefix, date, dir) {
    ## save output file
    save(junc.RPM, gene_expr, junc.RPM.norm, pvalues, pheno, FisherAnalyses, geneAnnotations,
        ASE.type, NORM.gene_expr.norm, junc.Outliers, splice_burden,
        file = paste0(dir, output_file_prefix, "_", date, ".RDa")
    )

    # Write Files
    write.table(ASE.type, file = paste0(
        dir, output_file_prefix, "_",
        date, "_", "event_types.txt"
    ), sep = "\t", quote = FALSE, col.names = NA)
    write.table(FisherAnalyses, file = paste0(
        dir, output_file_prefix, "_",
        date, "_", "FisherAnalyses.txt"
    ), sep = "\t", quote = FALSE, col.names = NA)
    write.table(as.data.frame(junc.Outliers$TumorOverExpression), file = paste0(
        dir, output_file_prefix, "_",
        date, "_", "TumorOverExpression.txt"
    ), sep = "\t", quote = FALSE, col.names = NA)
    write.table(as.data.frame(junc.Outliers$TumorUnderExpression), file = paste0(
        dir, output_file_prefix, "_",
        date, "_", "TumorUnderExpression.txt"
    ), sep = "\t", quote = FALSE, col.names = NA)
    write.table(splice_burden, file = paste0(
        dir, output_file_prefix, "_",
        date, "_", "splice_burden.txt"
    ), sep = "\t", quote = FALSE, col.names = NA)

    write.table(x = data.frame(geneAnnotations), file = paste0(
        dir, output_file_prefix, "_",
        date, "_", 'gene_annotations.txt'
    ), sep = '\t', col.names = TRUE, row.names=FALSE, quote = FALSE)
}

# Get Genomic Information for the Junctions and Determine the Event Type

getGenomicInfo <- function(junc.RPM, annotation, TxDb) {
    # create GenomicRanges object for junctions
    chr <- vapply(strsplit(row.names(junc.RPM), split = ":"), function(x) {
        x[[1]]
    }, character(1))
    start <- as.numeric(vapply(
        strsplit(row.names(junc.RPM), split = "[:-]"),
        function(x) {
            x[[2]]
        }, character(1)
    ))
    end <- as.numeric(vapply(
        strsplit(row.names(junc.RPM), split = "[:-]"),
        function(x) {
            x[[3]]
        }, character(1)
    ))


    geneAnnot <- GRanges(
        seqnames = Rle(chr),
        IRanges(start = start, end = end)
    )
    names(geneAnnot) <- row.names(junc.RPM)

    geneAnnotAll <- GRanges(
        seqnames = Rle(chr),
        IRanges(start = start, end = end)
    )
    names(geneAnnotAll) <- row.names(junc.RPM)

    # get GenomicRanges object with genes for whole genome
    gn <- genes(get(TxDb))

    gSymbol <- select(get(annotation),
        keys = as.character(gn$gene_id),
        columns = c("SYMBOL"), keytype = "ENTREZID"
    )
    gn$SYMBOL <- gSymbol$SYMBOL
    gn$ENTREZID <- gSymbol$ENTREZID
    rm(gSymbol, chr, end, start)
    gc()

    # find symbols and ENTREZID for our junctions
    overlap <- findOverlaps(geneAnnot, gn)

    geneSYMBOLS <- tapply(gn$SYMBOL[subjectHits(overlap)],
        queryHits(overlap), paste,
        collapse = ";"
    )

    # add to genome ranges object
    geneAnnot$SYMBOL <- NA
    geneAnnot$SYMBOL[as.numeric(names(geneSYMBOLS))] <- geneSYMBOLS

    geneENTREZID <- tapply(gn$ENTREZID[subjectHits(overlap)],
        queryHits(overlap), paste,
        collapse = ";"
    )

    geneAnnot$ENTREZID <- NA
    geneAnnot$ENTREZID[as.numeric(names(geneENTREZID))] <- geneENTREZID

    # get known exons
    en <- exons(get(TxDb))

    message("filtering for putative junctions, skipping, insertion and deletion events based on known exons.")
    # annotate skipping events as those which overlap with more than two exons
    exo <- findOverlaps(
        GRanges(seqnames(geneAnnot),
            ranges = IRanges(
                start = start(geneAnnot) + 1,
                end = end(geneAnnot) - 1
            ),
            strand = strand(geneAnnot)
        ), en,
        type = "within"
    )
    exoCount <- table(factor(queryHits(exo))) > 0
    geneAnnot$skipping <- FALSE
    geneAnnot$skipping[as.numeric(names(exoCount))] <- exoCount
    message("skipping")

    # insertion events start or end outside of known exons
    geneAnnot.start <- GRanges(seqnames(geneAnnot),
        ranges = IRanges(
            start = start(geneAnnot),
            end = start(geneAnnot)
        ),
        strand = strand(geneAnnot)
    )
    geneAnnot.end <- GRanges(seqnames(geneAnnot),
        ranges = IRanges(
            start = end(geneAnnot),
            end = end(geneAnnot)
        ),
        strand = strand(geneAnnot)
    )

    geneAnnot$insertions <- !overlapsAny(geneAnnot.start, en) |
        !overlapsAny(geneAnnot.end, en)

    message("insertions")

    # deletion events occur w/in an exon but not at its start or end
    en.start <- GRanges(seqnames(en),
        ranges = IRanges(
            start = start(en),
            end = start(en)
        ),
        strand = strand(en)
    )
    en.end <- GRanges(seqnames(en),
        ranges = IRanges(
            start = end(en),
            end = end(en)
        ),
        strand = strand(en)
    )
    geneAnnot$deletions <-
        (!overlapsAny(geneAnnot.end, en.start) & overlapsAny(geneAnnot.end, en)) |
            (!overlapsAny(geneAnnot.start, en.end) & overlapsAny(geneAnnot.start, en))

    message("deletions")

    return(geneAnnot)
}

# Plot Junction Expression Data

#' Create Bar and Waterfall plots of raw junction expression, overall gene expression, and junction expression normalized by gene expression for splicing events found by OutSplice.
#'
#' @title Create Plots of Junction Expression
#' @param data_file An R data file containing OutSplice Output.
#' @param NUMBER An integer indicating the number of junctions to plot. This can be top number of junctions (over or under expressed), or can be specific junctions in a list. Default is 1.
#' @param junctions A vector of user specified junctions that should be plotted. Default is NULL.
#' @param tail A character string indicating either "RIGHT" to plot the top over expressed junctions, or "LEFT" to plot the top under expressed junctions. Default is NULL.
#' @param p_value Set the alpha value for the significance threshold.
#' @param GENE A boolean indicating whether to plot junctions by a specific gene. TRUE means you will pick all the junctions mapping to a certain gene. FALSE means you do not pick based on the gene. Default is NULL.
#' @param SYMBOL The HGNC gene symbol of the gene to be graphed. Default is NULL.
#' @param makepdf A boolean specifying whether or not to save plots to a PDF. Default is FALSE.
#' @param pdffile A character string giving the file path to the desired pdf. Default is NULL.
#' @param tumcol A character string defining the color of the tumor samples in the plots. Default is red.
#' @param normcol A character string defining the color of the normal samples in the plots. Default is blue.
#' @return NULL. Displays or saves a pdf containing waterfall plots of junction expression.
#' @examples
#' data_file <- system.file("extdata", "OutSplice_Example_2023-01-06.RDa", package = "OutSplice")
#' ecm1_junc <- "chr1:150483674-150483933"
#' pdf <- "ecm1_expression.pdf"
#' pdf_output <- paste0(tempdir(), "/", pdf)
#' plotJunctionData(data_file, NUMBER = 1, junctions = ecm1_junc, tail = NULL, p_value = 0.05, GENE = FALSE, SYMBOL = NULL, makepdf = TRUE, pdffile = pdf_output, tumcol = "red", normcol = "blue")
#' message("Output is located at: ", pdf_output)
#' @references
#' Broad Institute TCGA Genome Data Analysis Center (2016): Firehose stddata__2016_01_28 run. Broad Institute of MIT and Harvard. doi:10.7908/C11G0KM9
#'
#' Cancer Genome Atlas Network. Comprehensive genomic characterization of head and neck squamous cell carcinomas. Nature. 2015 Jan 29;517(7536):576-82. doi: 10.1038/nature14129. PMID: 25631445; PMCID: PMC4311405.
#'
#' Guo T, Sakai A, Afsari B, Considine M, Danilova L, Favorov AV, Yegnasubramanian S, Kelley DZ, Flam E, Ha PK, Khan Z, Wheelan SJ, Gutkind JS, Fertig EJ, Gaykalova DA, Califano J. A Novel Functional Splice Variant of AKT3 Defined by Analysis of Alternative Splice Expression in HPV-Positive Oropharyngeal Cancers. Cancer Res. 2017 Oct 1;77(19):5248-5258. doi: 10.1158/0008-5472.CAN-16-3106. Epub 2017 Jul 21. PMID: 28733453; PMCID: PMC6042297.
#'
#' Liu C, Guo T, Sakai A, Ren S, Fukusumi T, Ando M, Sadat S, Saito Y, Califano JA. A novel splice variant of LOXL2 promotes progression of human papillomavirus-negative head and neck squamous cell carcinoma. Cancer. 2020 Feb 15;126(4):737-748. doi: 10.1002/cncr.32610. Epub 2019 Nov 13. PMID: 31721164.
#'
#' Liu C, Guo T, Xu G, Sakai A, Ren S, Fukusumi T, Ando M, Sadat S, Saito Y, Khan Z, Fisch KM, Califano J. Characterization of Alternative Splicing Events in HPV-Negative Head and Neck Squamous Cell Carcinoma Identifies an Oncogenic DOCK5 Variant. Clin Cancer Res. 2018 Oct 15;24(20):5123-5132. doi: 10.1158/1078-0432.CCR-18-0752. Epub 2018 Jun 26. PMID: 29945995; PMCID: PMC6440699.
#'
#' M. F. Ochs, J. E. Farrar, M. Considine, Y. Wei, S. Meshinchi, and R. J. Arceci. Outlier analysis and top scoring pair for integrated data analysis and biomarker discovery. IEEE/ACM Trans Comput Biol Bioinform, 11: 520-32, 2014. PMCID: PMC4156935
#' @export
plotJunctionData <- function(data_file, NUMBER = 1, junctions = NULL, tail = NULL,
                             p_value = 0.05, GENE = FALSE, SYMBOL = NULL, makepdf = FALSE,
                             pdffile = NULL, tumcol = "red", normcol = "blue") {
    stopifnot("R Data File does not exist. Check path to file." = file.exists(data_file))
    if (!NUMBER > 0) {
        stop("NUMBER must be an integer greater than 0.")
    }
    if (!is.null(SYMBOL)) {
        if (GENE == FALSE) stop("Need to set the GENE argument to TRUE.")
    }
    suppressPackageStartupMessages(load(data_file))
    ## if you want to make a pdf, this will be specified.  Stop/error if not specified
    ## the number of junctions to be ploted should be equal or greater than the number of significant junctions that exist
    if (makepdf == TRUE) {
        if (is.null(pdffile)) {
            stop("Need to specify PDF file path name. pdffile=...")
        }
        if (isTRUE(tail) && tail == "RIGHT") {
            if (sum(FisherAnalyses[, "FisherP2"] < p_value) < NUMBER) {
                stop("Number of significant junctions is less than the number of junctions specified.")
            }
        } else if (isTRUE(tail) && tail == "LEFT") {
            if (sum(FisherAnalyses[, "FisherP1"] < p_value) < NUMBER) {
                stop("Number of significant junctions is less than the number of junctions specified.")
            }
        }
        pdf(pdffile)
    }
    ## Define which junctions are going to be graphed
    ## if you do not define which specific junctions you want to graph
    if (is.null(junctions)) {
        if (GENE == FALSE) {
            if (is.null(tail)) {
                junctions <- row.names(junc.RPM)[seq_len(NUMBER)]
            } else if (tail == "RIGHT") {
                toplist90 <- subset_overEx(FisherAnalyses, p_value)
                junctions <- row.names(toplist90)[seq_len(NUMBER)]
                message("Top ", NUMBER, " overexpressed junctions graphed.")
            } else if (tail == "LEFT") {
                toplist10 <- subset_underEx(FisherAnalyses, p_value)
                junctions <- row.names(toplist10)[seq_len(NUMBER)]
                message("Top ", NUMBER, " underexpressed junctions graphed.")
            }
        } else if (GENE == TRUE) {
            if (is.null(SYMBOL)) stop("Need to specify gene of interest by gene symbol. SYMBOL='...'")
            junctions <- names(geneAnnotations)[grep(SYMBOL, geneAnnotations$SYMBOL)]
            message(length(junctions), " junction(s) for gene ", SYMBOL, " found.")
        }
    }

    if (length(junctions) == 0) stop("No junctions found.")
    count <- 0
    par(mfrow = c(2, 2), oma = c(0, 0, 2, 0))
    for (j in junctions)
    {
        ## first barplot is for raw junction data
        message(j)
        phenotypes <- as.data.frame(pheno)
        samples <- order(phenotypes$pheno, junc.RPM.norm[j, ], junc.RPM.norm[j, ])
        barplot(log2(junc.RPM[j, samples] + 1),
            cex.names = 0.3, las = 2,
            col = ifelse(phenotypes[samples, "pheno"] == "Tumor", tumcol, normcol)
        )
        title(sprintf(
            "Junction Expression (log)\nskip? %s del? %s? ins? %s",
            geneAnnotations[j, ]$skipping, geneAnnotations[j, ]$deletions,
            geneAnnotations[j, ]$insertions
        ), cex.main = 0.7)

        ## this plot is for normalized junction expression - with gene_expr.
        barplot(log2(junc.RPM.norm[j, samples] + 1) - log2(NORM.gene_expr.norm[j] + 1),
            las = 2, cex.names = 0.3,
            col = ifelse(phenotypes[samples, "pheno"] == "Tumor", tumcol, normcol)
        )
        title("Junction expression \nNormalized by gene_expr (log)", cex.main = 0.7)

        ## this barplot is for gene_expr of gene expression
        barplot(log2(gene_expr[j, samples] + 1),
            las = 2, cex.names = 0.3,
            col = ifelse(phenotypes[samples, "pheno"] == "Tumor", tumcol, normcol)
        )
        title(sprintf("%s \ngene_expr gene expression", geneAnnotations[j, ]$SYMBOL), cex.main = 0.7)

        plot.new()

        count <- count + 1
    }



    if (makepdf == TRUE) dev.off()
}

test_that("Junction Plotting Works for User Specified Junctions", {
    data_file <- system.file("extdata", "OutSplice_Example_2023-01-06.RDa", package = "OutSplice")
    pdf_output <- paste0(tempdir(), "/", "ecm1_expression.pdf")
    junc_plots <- plotJunctionData(data_file, NUMBER = 1, junctions = "chr1:150483674-150483933", tail = NULL, p_value = 0.05, GENE = FALSE, SYMBOL = NULL, makepdf = TRUE, pdffile = pdf_output, tumcol = "red", normcol = "blue")
    expect_no_error(junc_plots)
})

test_that("Junction Plotting Works for Over-Expressed Tail Values", {
    data_file <- system.file("extdata", "OutSplice_Example_2023-01-06.RDa", package = "OutSplice")
    pdf_output <- paste0(tempdir(), "/", "top2_OE.pdf")
    junc_plots <- plotJunctionData(data_file, NUMBER = 2, tail = "RIGHT", p_value = 0.05, GENE = FALSE, SYMBOL = NULL, makepdf = TRUE, pdffile = pdf_output, tumcol = "red", normcol = "blue")
    expect_no_error(junc_plots)
})

test_that("Junction Plotting Works for Under-Expressed Tail Values", {
    data_file <- system.file("extdata", "OutSplice_Example_2023-01-06.RDa", package = "OutSplice")
    pdf_output <- paste0(tempdir(), "/", "top2_UE.pdf")
    junc_plots <- plotJunctionData(data_file, NUMBER = 2, tail = "LEFT", p_value = 0.05, GENE = FALSE, SYMBOL = NULL, makepdf = TRUE, pdffile = pdf_output, tumcol = "red", normcol = "blue")
    expect_no_error(junc_plots)
})

test_that("Junction Plotting Works for Under-Expressed Tail Values", {
    data_file <- system.file("extdata", "OutSplice_Example_2023-01-06.RDa", package = "OutSplice")
    pdf_output <- paste0(tempdir(), "/", "ecm1_gene_expression.pdf")
    junc_plots <- plotJunctionData(data_file, p_value = 0.05, GENE = TRUE, SYMBOL = "ECM1", makepdf = TRUE, pdffile = pdf_output, tumcol = "red", normcol = "blue")
    expect_no_error(junc_plots)
})

# Collect Gene Expression values from normalized expression matrix

getExpressions <- function(geneAnnot, all.gene_expr, gene_exprEntrezID) {
    ## collect gene_expr values
    # initialize matrix of values for each junction
    junctionGenegene_expr <- matrix(0,
        nrow = length(geneAnnot), ncol = ncol(all.gene_expr),
        dimnames = list(names(geneAnnot), colnames(all.gene_expr))
    )

    geneAnnot$ENTREZID -> genes2Junc_ENTREZ
    names(genes2Junc_ENTREZ) <- names(geneAnnot)

    ## shows how many junctions aligned to a single gene"
    length(grep(genes2Junc_ENTREZ, pattern = ";", invert = TRUE, value = TRUE))

    ### Make sure the genes are ordered by lower to higher ENTREZID
    genes2Junc_ENTREZ <- vapply(genes2Junc_ENTREZ, function(x)
        paste(sort(as.numeric(strsplit(x, ";")[[1]])), collapse = ";"), character(1))

    ## this selects just the first gene that each junction aligns to
    genes2Junc_ENTREZ <- vapply(strsplit(genes2Junc_ENTREZ, ";"), function(x) {
        x[1]
    }, character(1))

    ## fill in the matrix
    no.gene_expr <- vector(length = length(genes2Junc_ENTREZ))
    for (g in seq_along(genes2Junc_ENTREZ)) {
        if (!isTRUE(intersect(gene_exprEntrezID, genes2Junc_ENTREZ[g]) > 0)) {
            ## for gene where there is no gene_expr data, skip it
            no.gene_expr[g] <- TRUE
            next
        }
        junctionGenegene_expr[names(genes2Junc_ENTREZ)[g], ] <-
            all.gene_expr[which(gene_exprEntrezID == genes2Junc_ENTREZ[g]), ]
    }

    ################################################################
    ## Remove genes without gene_expr data, not in true genes
    junctionGenegene_expr[!no.gene_expr, ] -> junctionGenegene_expr

    return(junctionGenegene_expr)
}

# Function to normalize by Total Read Counts and remove junctions with no difference between tumor and normal

getRPM <- function(rawcounts, all.junc, all.samples) {
    ## get data in RPM
    message("convert to RPM")
    totalrawcount <- colSums(rawcounts)
    names(totalrawcount) <- colnames(rawcounts)
    junc.RPM <- apply(all.junc[, all.samples], 1, function(x) {
        x / totalrawcount[all.samples] * 1000000
    })
    junc.RPM <- t(junc.RPM)

    message("filter the putative junctions")
    ### filter genes by cut off of
    fcCutoff <- 10
    Cutoff.ratio <- 1 - (1 / fcCutoff)
    # enforce overall Fold change
    logFC <- apply(junc.RPM, 1, function(x) {
        (max(x) - min(x)) / max(x)
    }) > Cutoff.ratio
    junc.RPM <- junc.RPM[which(logFC), ]

    rm(logFC)
    gc()

    return(junc.RPM)
}

# Function to subset significant over-expressed junction events

subset_overEx <- function(FisherAnalyses, p_value) {
    toplist90 <- FisherAnalyses[order(FisherAnalyses$OE_Rank), ]
    if (sum(toplist90[, "FisherP2"] < p_value) > 0) {
        toplist90 <- toplist90[toplist90[, "FisherP2"] < p_value, ]
        toplist90 <- subset(toplist90, select = FisherP2)
    } else {
        toplist90 <- NULL
    }
    return(toplist90)
}

# Function to normalize junction data by gene expression values

normalizeJunctions <- function(junc.RPM2, junctionGenegene_expr) {
    ## Turn all the zeros in junctionGenegene_expr into 1.
    ## replace ALL zeros with 1.  Then when you divide it does not do anything.
    junctionGenegene_expr <- junctionGenegene_expr[row.names(junc.RPM2), ]
    junctionGenegene_expr2 <- junctionGenegene_expr
    junctionGenegene_expr2[junctionGenegene_expr == 0] <- 1
    junc.RPM.norm <- junc.RPM2
    junc.RPM.norm <- junc.RPM2 / junctionGenegene_expr2

    return(junc.RPM.norm)
}

## ----setup, include=FALSE-----------------------------------------------------
knitr::opts_chunk$set(echo = TRUE)

## ----echo = FALSE, eval=FALSE-------------------------------------------------
# if (!require("BiocManager")) {
#     install.packages("BiocManager")
# }
# BiocManager::install("OutSplice")

## ----message=FALSE------------------------------------------------------------
library(OutSplice)

## ----results="hide", warning=FALSE, messages = FALSE--------------------------
junction <- system.file("extdata", "HNSC_junctions.txt.gz", package = "OutSplice")
gene_expr <- system.file("extdata", "HNSC_genes_normalized.txt.gz", package = "OutSplice")
rawcounts <- system.file("extdata", "Total_Rawcounts.txt", package = "OutSplice")
sample_labels <- system.file("extdata", "HNSC_pheno_table.txt", package = "OutSplice")
output_file_prefix <- "OutSplice_Example"
TxDb_hg19 <- "TxDb.Hsapiens.UCSC.hg19.knownGene"
dir <- paste0(tempdir(), "/")
message("Output is located at: ", dir)

results <- outspliceAnalysis(junction, gene_expr, rawcounts, sample_labels, saveOutput = TRUE, output_file_prefix, dir, filterSex = TRUE, annotation = "org.Hs.eg.db", TxDb = TxDb_hg19, offsets_value = 0.00001, correction_setting = "fdr", p_value = 0.05)

## ----results="hide", warning=FALSE, messages = FALSE--------------------------
junction <- system.file("extdata", "TCGA_HNSC_junctions.txt.gz", package = "OutSplice")
gene_expr <- system.file("extdata", "TCGA_HNSC_genes_normalized.txt.gz", package = "OutSplice")
rawcounts <- system.file("extdata", "Total_Rawcounts.txt", package = "OutSplice")
output_file_prefix <- "TCGA_OutSplice_Example"
dir <- paste0(tempdir(), "/")
message("Output is located at: ", dir)

results_TCGA <- outspliceTCGA(junction, gene_expr, rawcounts, saveOutput = TRUE, output_file_prefix, dir, filterSex = TRUE, annotation = "org.Hs.eg.db", TxDb = "TxDb.Hsapiens.UCSC.hg19.knownGene", offsets_value = 0.00001, correction_setting = "fdr", p_value = 0.05)

## ----results="hide", warning=FALSE, messages=FALSE----------------------------
data_file <- system.file("extdata", "OutSplice_Example_2023-01-06.RDa", package = "OutSplice")
ecm1_junc <- "chr1:150483674-150483933"
pdf <- "ecm1_expression.pdf"
pdf_output <- paste0(tempdir(), "/", pdf)
message("Output is located at: ", pdf_output)

plotJunctionData(data_file, NUMBER = 1, junctions = ecm1_junc, tail = NULL, p_value = 0.05, GENE = FALSE, SYMBOL = NULL, makepdf = TRUE, pdffile = pdf_output, tumcol = "red", normcol = "blue")

## -----------------------------------------------------------------------------
sessionInfo()

## The R Data File in the /inst/extdata subdirectory was generated by running the OutSplice function
## on the example files in the /inst/extdata subdirectory using the hg19 build for annotations. The description as to
## how these files were made is documented below.

## The following script outlines the process used to create the trimmed example data from the TCGA used in the OutSplice vignette and man files

#1. First, download the zipped directories from the TGCA: http://firebrowse.org/?cohort=HNSC&download_dialog=true
# The directories are: "illuminahiseq_rnaseqv2-junction_quantification," "illuminahiseq_rnaseqv2-RSEM_genes_normalized," "mRNAseq_Preprocess"
# From these directories extract the following: "HNSC.rnaseqv2__illuminahiseq_rnaseqv2__unc_edu__Level_3__junction_quantification__data.data.txt", "HNSC.rnaseqv2__illuminahiseq_rnaseqv2__unc_edu__Level_3__RSEM_genes_normalized__data.data.txt" ,"HNSC.uncv2.mRNAseq_raw_counts.txt"

#2. For ease, rename the files: "full_HNSC_junctions.txt", "full_HNSC_genes_normalized.txt", "full_HNSC_raw_counts_unc.txt"

#3. Set the working directory to the directory containing the files and read in the data
juncs_file<-read.table(file="full_HNSC_junctions.txt", sep='\t', header=T, stringsAsFactors = F)
RSEM_file<-read.table(file="full_HNSC_genes_normalized.txt", header=T, row.names=1, sep="\t")
rawcounts_file<-read.table(file="full_HNSC_raw_counts_unc.txt", sep='\t', header=T, row.names=1, stringsAsFactors = F)

#4. In the junction file, drop all rows not on chromosome 1. This is rows 25237-249578
juncs_file <- juncs_file[-(25237:249578),]

#5. Subset Example Tumors and Normals
library(dplyr)
colnames(rawcounts_file)<-gsub('\\.', "-", colnames(rawcounts_file))
colnames(juncs_file)<-gsub('\\.', "-", colnames(juncs_file))
colnames(RSEM_file)<-gsub('\\.', "-", colnames(RSEM_file))
rawcounts <- rawcounts_file %>% dplyr::select("TCGA-BA-5152-01",	"TCGA-BA-6869-01",	"TCGA-BA-A6DL-01",	"TCGA-BB-4227-01",	"TCGA-BB-7864-01",
                                      "TCGA-CN-4725-01",	"TCGA-CN-4727-01",	"TCGA-CN-4730-01",	"TCGA-CN-4731-01",	"TCGA-CN-4736-01",
                                      "TCGA-CN-4739-01",	"TCGA-CN-6988-01",	"TCGA-CN-A49C-01",	"TCGA-CN-A63W-01",	"TCGA-CN-A641-01",
                                      "TCGA-CQ-5327-01",	"TCGA-CQ-6227-01",	"TCGA-CQ-7065-01",	"TCGA-CQ-7069-01",	"TCGA-CQ-A4C9-01",
                                      "TCGA-CR-5247-01",	"TCGA-CR-6477-01",	"TCGA-CR-6480-01",	"TCGA-CR-7364-01",	"TCGA-CR-7365-01",
                                      "TCGA-CR-7369-01",	"TCGA-CR-7385-01",	"TCGA-CV-6933-11",	"TCGA-CV-6934-11",	"TCGA-CV-6935-11",
                                      "TCGA-CV-6936-11",	"TCGA-CV-6938-11",	"TCGA-CV-6939-11",	"TCGA-CV-6943-11",	"TCGA-CV-6952-01",
                                      "TCGA-CV-6955-11",	"TCGA-CV-6956-01",	"TCGA-CV-6956-11",	"TCGA-CV-6959-11",	"TCGA-CV-6960-11",
                                      "TCGA-CV-6961-11",	"TCGA-CV-6962-11",	"TCGA-CV-7089-01",	"TCGA-CV-7091-11",	"TCGA-CV-7095-01",
                                      "TCGA-CV-7097-11",	"TCGA-CV-7101-11",	"TCGA-CV-7103-11",	"TCGA-CV-7177-11",	"TCGA-CV-7178-11",
                                      "TCGA-CV-7183-11",	"TCGA-CV-7235-11",	"TCGA-CV-7238-11",	"TCGA-CV-7242-01",	"TCGA-CV-7242-11",
                                      "TCGA-CV-7245-11",	"TCGA-CV-7250-01",	"TCGA-CV-7250-11",	"TCGA-CV-7252-11",	"TCGA-CV-7253-01",
                                      "TCGA-CV-7255-01",	"TCGA-CV-7255-11",	"TCGA-CV-7261-11",	"TCGA-CV-7406-11",	"TCGA-CV-7409-01",
                                      "TCGA-CV-7416-11",	"TCGA-CV-7423-11",	"TCGA-CV-7424-11",	"TCGA-CV-7425-11",	"TCGA-CV-7432-11",
                                      "TCGA-CV-7434-11",	"TCGA-CV-7437-11",	"TCGA-CV-7438-11",	"TCGA-CV-7440-11",	"TCGA-CV-7568-01",
                                      "TCGA-CV-A45R-01",	"TCGA-CX-7086-01",	"TCGA-D6-A6EO-01",	"TCGA-F7-7848-01",	"TCGA-H7-A6C4-01",
                                      "TCGA-H7-A6C4-11",	"TCGA-H7-A6C5-11",	"TCGA-HD-7917-01",	"TCGA-HD-8224-01",	"TCGA-HD-8635-11",
                                      "TCGA-HD-A6HZ-11",	"TCGA-HD-A6I0-11",	"TCGA-IQ-7632-01",	"TCGA-P3-A5QF-01",	"TCGA-P3-A6T8-01",
                                      "TCGA-TN-A7HJ-01",	"TCGA-UF-A719-01",	"TCGA-UF-A71D-01",	"TCGA-WA-A7GZ-11")

all.junc <- juncs_file %>% dplyr::select("Hybridization-REF", "TCGA-BA-5152-01A-02R-1873-07",	"TCGA-BA-6869-01A-11R-1873-07",	"TCGA-BA-A6DL-01A-21R-A30B-07",	"TCGA-BB-4227-01A-01R-1873-07",	"TCGA-BB-7864-01A-11R-2232-07",
                                 "TCGA-CN-4725-01A-01R-1436-07",	"TCGA-CN-4727-01A-01R-1436-07",	"TCGA-CN-4730-01A-01R-1436-07",	"TCGA-CN-4731-01A-01R-1436-07",	"TCGA-CN-4736-01A-01R-1436-07",
                                 "TCGA-CN-4739-01A-02R-1514-07",	"TCGA-CN-6988-01A-11R-1915-07",	"TCGA-CN-A49C-01A-11R-A24H-07",	"TCGA-CN-A63W-01A-11R-A30B-07",	"TCGA-CN-A641-01A-11R-A30B-07",
                                 "TCGA-CQ-5327-01A-01R-1686-07",	"TCGA-CQ-6227-01A-11R-1915-07",	"TCGA-CQ-7065-01A-11R-2081-07",	"TCGA-CQ-7069-01A-11R-2403-07",	"TCGA-CQ-A4C9-01A-11R-A24Z-07",
                                 "TCGA-CR-5247-01A-01R-2016-07",	"TCGA-CR-6477-01A-11R-1873-07",	"TCGA-CR-6480-01A-11R-1873-07",	"TCGA-CR-7364-01A-11R-2016-07",	"TCGA-CR-7365-01A-11R-2016-07",
                                 "TCGA-CR-7369-01A-11R-2132-07",	"TCGA-CR-7385-01A-11R-2016-07",	"TCGA-CV-6933-11A-01R-1915-07",	"TCGA-CV-6934-11A-01R-1915-07",	"TCGA-CV-6935-11A-01R-1915-07",
                                 "TCGA-CV-6936-11A-01R-1915-07",	"TCGA-CV-6938-11A-01R-1915-07",	"TCGA-CV-6939-11A-01R-1915-07",	"TCGA-CV-6943-11A-01R-1915-07",	"TCGA-CV-6952-01A-11R-1915-07",
                                 "TCGA-CV-6955-11A-01R-2016-07",	"TCGA-CV-6956-01A-21R-2016-07",	"TCGA-CV-6956-11A-01R-2016-07",	"TCGA-CV-6959-11A-01R-1915-07",	"TCGA-CV-6960-11A-01R-2016-07",
                                 "TCGA-CV-6961-11A-01R-1915-07",	"TCGA-CV-6962-11A-01R-1915-07",	"TCGA-CV-7089-01A-11R-2016-07",	"TCGA-CV-7091-11A-01R-2016-07",	"TCGA-CV-7095-01A-21R-2016-07",
                                 "TCGA-CV-7097-11A-01R-2016-07",	"TCGA-CV-7101-11A-01R-2016-07",	"TCGA-CV-7103-11A-01R-2016-07",	"TCGA-CV-7177-11A-01R-2016-07",	"TCGA-CV-7178-11A-01R-2016-07",
                                 "TCGA-CV-7183-11A-01R-2016-07",	"TCGA-CV-7235-11A-01R-2016-07",	"TCGA-CV-7238-11A-01R-2016-07",	"TCGA-CV-7242-01A-11R-2016-07",	"TCGA-CV-7242-11A-01R-2016-07",
                                 "TCGA-CV-7245-11A-01R-2016-07",	"TCGA-CV-7250-01A-11R-2016-07",	"TCGA-CV-7250-11A-01R-2016-07",	"TCGA-CV-7252-11A-01R-2016-07",	"TCGA-CV-7253-01A-11R-2016-07",
                                 "TCGA-CV-7255-01A-11R-2016-07",	"TCGA-CV-7255-11A-01R-2016-07",	"TCGA-CV-7261-11A-01R-2016-07",	"TCGA-CV-7406-11A-01R-2081-07",	"TCGA-CV-7409-01A-31R-2232-07",
                                 "TCGA-CV-7416-11A-01R-2081-07",	"TCGA-CV-7423-11A-01R-2081-07",	"TCGA-CV-7424-11A-01R-2081-07",	"TCGA-CV-7425-11A-01R-2081-07",	"TCGA-CV-7432-11A-01R-2132-07",
                                 "TCGA-CV-7434-11A-01R-2132-07",	"TCGA-CV-7437-11A-01R-2132-07",	"TCGA-CV-7438-11A-01R-2132-07",	"TCGA-CV-7440-11A-01R-2187-07",	"TCGA-CV-7568-01A-11R-2232-07",
                                 "TCGA-CV-A45R-01A-11R-A24H-07",	"TCGA-CX-7086-01A-11R-2081-07",	"TCGA-D6-A6EO-01A-11R-A31N-07",	"TCGA-F7-7848-01A-11R-2132-07",	"TCGA-H7-A6C4-01A-11R-A30B-07",
                                 "TCGA-H7-A6C4-11A-21R-A466-07",	"TCGA-H7-A6C5-11A-11R-A30B-07",	"TCGA-HD-7917-01A-11R-2232-07",	"TCGA-HD-8224-01A-11R-2403-07",	"TCGA-HD-8635-11A-01R-2403-07",
                                 "TCGA-HD-A6HZ-11A-11R-A31N-07",	"TCGA-HD-A6I0-11A-11R-A31N-07",	"TCGA-IQ-7632-01A-11R-2081-07",	"TCGA-P3-A5QF-01A-11R-A28V-07",	"TCGA-P3-A6T8-01A-11R-A34R-07",
                                 "TCGA-TN-A7HJ-01A-12R-A34R-07",	"TCGA-UF-A719-01A-12R-A34R-07",	"TCGA-UF-A71D-01A-12R-A34R-07",	"TCGA-WA-A7GZ-11A-11R-A34R-07")
junctions_with_strand_info <- all.junc
junc_original_sample_names <- colnames(junctions_with_strand_info)
junc_original_sample_names <- junc_original_sample_names[-1]

all.RSEM <- RSEM_file %>% dplyr::select("TCGA-BA-5152-01A-02R-1873-07",	"TCGA-BA-6869-01A-11R-1873-07",	"TCGA-BA-A6DL-01A-21R-A30B-07",	"TCGA-BB-4227-01A-01R-1873-07",	"TCGA-BB-7864-01A-11R-2232-07",
                                "TCGA-CN-4725-01A-01R-1436-07",	"TCGA-CN-4727-01A-01R-1436-07",	"TCGA-CN-4730-01A-01R-1436-07",	"TCGA-CN-4731-01A-01R-1436-07",	"TCGA-CN-4736-01A-01R-1436-07",
                                "TCGA-CN-4739-01A-02R-1514-07",	"TCGA-CN-6988-01A-11R-1915-07",	"TCGA-CN-A49C-01A-11R-A24H-07",	"TCGA-CN-A63W-01A-11R-A30B-07",	"TCGA-CN-A641-01A-11R-A30B-07",
                                "TCGA-CQ-5327-01A-01R-1686-07",	"TCGA-CQ-6227-01A-11R-1915-07",	"TCGA-CQ-7065-01A-11R-2081-07",	"TCGA-CQ-7069-01A-11R-2403-07",	"TCGA-CQ-A4C9-01A-11R-A24Z-07",
                                "TCGA-CR-5247-01A-01R-2016-07",	"TCGA-CR-6477-01A-11R-1873-07",	"TCGA-CR-6480-01A-11R-1873-07",	"TCGA-CR-7364-01A-11R-2016-07",	"TCGA-CR-7365-01A-11R-2016-07",
                                "TCGA-CR-7369-01A-11R-2132-07",	"TCGA-CR-7385-01A-11R-2016-07",	"TCGA-CV-6933-11A-01R-1915-07",	"TCGA-CV-6934-11A-01R-1915-07",	"TCGA-CV-6935-11A-01R-1915-07",
                                "TCGA-CV-6936-11A-01R-1915-07",	"TCGA-CV-6938-11A-01R-1915-07",	"TCGA-CV-6939-11A-01R-1915-07",	"TCGA-CV-6943-11A-01R-1915-07",	"TCGA-CV-6952-01A-11R-1915-07",
                                "TCGA-CV-6955-11A-01R-2016-07",	"TCGA-CV-6956-01A-21R-2016-07",	"TCGA-CV-6956-11A-01R-2016-07",	"TCGA-CV-6959-11A-01R-1915-07",	"TCGA-CV-6960-11A-01R-2016-07",
                                "TCGA-CV-6961-11A-01R-1915-07",	"TCGA-CV-6962-11A-01R-1915-07",	"TCGA-CV-7089-01A-11R-2016-07",	"TCGA-CV-7091-11A-01R-2016-07",	"TCGA-CV-7095-01A-21R-2016-07",
                                "TCGA-CV-7097-11A-01R-2016-07",	"TCGA-CV-7101-11A-01R-2016-07",	"TCGA-CV-7103-11A-01R-2016-07",	"TCGA-CV-7177-11A-01R-2016-07",	"TCGA-CV-7178-11A-01R-2016-07",
                                "TCGA-CV-7183-11A-01R-2016-07",	"TCGA-CV-7235-11A-01R-2016-07",	"TCGA-CV-7238-11A-01R-2016-07",	"TCGA-CV-7242-01A-11R-2016-07",	"TCGA-CV-7242-11A-01R-2016-07",
                                "TCGA-CV-7245-11A-01R-2016-07",	"TCGA-CV-7250-01A-11R-2016-07",	"TCGA-CV-7250-11A-01R-2016-07",	"TCGA-CV-7252-11A-01R-2016-07",	"TCGA-CV-7253-01A-11R-2016-07",
                                "TCGA-CV-7255-01A-11R-2016-07",	"TCGA-CV-7255-11A-01R-2016-07",	"TCGA-CV-7261-11A-01R-2016-07",	"TCGA-CV-7406-11A-01R-2081-07",	"TCGA-CV-7409-01A-31R-2232-07",
                                "TCGA-CV-7416-11A-01R-2081-07",	"TCGA-CV-7423-11A-01R-2081-07",	"TCGA-CV-7424-11A-01R-2081-07",	"TCGA-CV-7425-11A-01R-2081-07",	"TCGA-CV-7432-11A-01R-2132-07",
                                "TCGA-CV-7434-11A-01R-2132-07",	"TCGA-CV-7437-11A-01R-2132-07",	"TCGA-CV-7438-11A-01R-2132-07",	"TCGA-CV-7440-11A-01R-2187-07",	"TCGA-CV-7568-01A-11R-2232-07",
                                "TCGA-CV-A45R-01A-11R-A24H-07",	"TCGA-CX-7086-01A-11R-2081-07",	"TCGA-D6-A6EO-01A-11R-A31N-07",	"TCGA-F7-7848-01A-11R-2132-07",	"TCGA-H7-A6C4-01A-11R-A30B-07",
                                "TCGA-H7-A6C4-11A-21R-A466-07",	"TCGA-H7-A6C5-11A-11R-A30B-07",	"TCGA-HD-7917-01A-11R-2232-07",	"TCGA-HD-8224-01A-11R-2403-07",	"TCGA-HD-8635-11A-01R-2403-07",
                                "TCGA-HD-A6HZ-11A-11R-A31N-07",	"TCGA-HD-A6I0-11A-11R-A31N-07",	"TCGA-IQ-7632-01A-11R-2081-07",	"TCGA-P3-A5QF-01A-11R-A28V-07",	"TCGA-P3-A6T8-01A-11R-A34R-07",
                                "TCGA-TN-A7HJ-01A-12R-A34R-07",	"TCGA-UF-A719-01A-12R-A34R-07",	"TCGA-UF-A71D-01A-12R-A34R-07",	"TCGA-WA-A7GZ-11A-11R-A34R-07")
rsem_with_all_genes <- all.RSEM

#6. To further trim the file, pre-filter the junctions to only include biologically relevant junctions. To do this we will source the OGSA scripts from OutSplice. Please edit the below code if your working directory is not the inst/script folder in the OutSplice pakcage.
setwd('../../R')
dir = getwd()
print(dir)
source(paste0(dir, '/OGSAfunctionwFisher.R'))
source(paste0(dir, '/outCallRank.R'))
setwd('../inst/script')

colnames(rawcounts)<-substr(colnames(rawcounts), 1,15)
colnames(rawcounts)<-gsub('\\.', "-", colnames(rawcounts))

#remove header; rename row names and junctions
all.junc<-all.junc[-1,] # remove header
all.RSEM<-all.RSEM[-1,] # remove header

all.samples<-colnames(all.junc)
all.samples<-substr(all.samples, 1, 15)
all.samples<-gsub('\\.', '-', all.samples)
junction.names<-all.junc[,1]
#remove duplicates
all.junc<-all.junc[!duplicated(junction.names),]
junction.names<-all.junc[,1]
j<-paste0(vapply(strsplit(junction.names,split=":"), function(x){x[[1]]}), ":", vapply(strsplit(junction.names,split=":"), function(x){x[[2]]}), "-",vapply(strsplit(junction.names,split=":"), function(x){x[[4]]}))

rownames(all.junc)<-j
colnames(all.junc)<-all.samples
#remove first column
all.junc<-all.junc[,-1]

expression.samples<-substr(colnames(all.RSEM), 1, 15)
expression.samples<-gsub('\\.', '-', expression.samples)
colnames(all.RSEM)<-expression.samples

#infer phenotype from sample names
all.samples<-intersect(colnames(all.junc), colnames(all.RSEM))
all.samples<-intersect(all.samples, colnames(rawcounts))
pheno<-substr(all.samples, 14,15)
names(pheno)<-all.samples
# include only primary tumor 01 or normal 11
pheno<-pheno[pheno=='01'|pheno=="11"]
pheno[pheno=='01']<-"Tumor"
pheno[pheno=='11']<-"Normal"
print(table(pheno))

if (sum(pheno=="Normal")<10){
  stop('Too few normal samples')
}
#subset only primary tumor 01 or normal 11
all.samples<-names(pheno)
all.junc<-all.junc[,all.samples]
all.RSEM<-all.RSEM[,all.samples]
rawcounts<-rawcounts[,all.samples]
pheno<-pheno[all.samples]

##change from char to numeric
n<-vapply(all.RSEM, as.numeric)
rownames(n)<-rownames(all.RSEM)
all.RSEM<-n
n<-vapply(all.junc, as.numeric)
rownames(n)<-rownames(all.junc)
all.junc<-n
remove(n)

## get data in RPM
print("convert to RPM")
totalrawcount<-colSums(rawcounts)
names(totalrawcount)<-colnames(rawcounts)
junc.RPM<-apply(all.junc[,all.samples], 1, function(x){x/totalrawcount[all.samples]*1000000})
junc.RPM<-t(junc.RPM)

print("filter the putative junctions")
### filter genes by cut off of
fcCutoff=10
Cutoff.ratio<-1-(1/fcCutoff)
# enforce overall Fold change
logFC <- apply(junc.RPM,1,function(x){(max(x)-min(x))/max(x)}) > Cutoff.ratio
junc.RPM <- junc.RPM[which(logFC),]

rm(logFC)
gc()

###### NEW FILTER: See if tumors have any outliers ###########################
##PHENO should have 'Normal' or 'Tumor' calls where Tumor ==1, Normal ==0, and names of each sample associated
PHENO<-pheno=='Tumor'
PHENO<-as.numeric(PHENO)
names(PHENO)<-names(pheno)

print("run the ogsa function for pre filtering")
## get function
test2<-dotheogsa(Sample.data=junc.RPM, PHENO=PHENO, offsets=0.1, dir = dir)
has.outliers<-test2[,"outRankTumor1"]>1|test2[,"outRankTumor2"]>1
junc.RPM<-junc.RPM[has.outliers,]

### Filter all genes on the X and Y chromosomes

junc.RPM <- junc.RPM[grep('chr[XY]',row.names(junc.RPM),value=T,invert=T),]

#7. Map Junctions in junc.RPM back to the original file to choose which junctions to keep
#remove header; rename row names and junctions
junctions_with_strand_info<-junctions_with_strand_info[-1,] # remove header

all.samples<-colnames(junctions_with_strand_info)
all.samples<-substr(all.samples, 1, 15)
all.samples<-gsub('\\.', '-', all.samples)
junction.names<-junctions_with_strand_info[,1]
#remove duplicates
junctions_with_strand_info<-junctions_with_strand_info[!duplicated(junction.names),]
junction.names<-junctions_with_strand_info[,1]
j<-paste0(vapply(strsplit(junction.names,split=":"), function(x){x[[1]]}), ":", vapply(strsplit(junction.names,split=":"), function(x){x[[2]]}), "-",vapply(strsplit(junction.names,split=":"), function(x){x[[4]]}))

rownames(junctions_with_strand_info)<-j
colnames(junctions_with_strand_info)<-all.samples

#Load List of Junctions that passed a pre-filter and merge
junctions_with_strand_info$id <- 1:nrow(junctions_with_strand_info)

final_junctions <- merge(junc.RPM, junctions_with_strand_info, by = 'row.names')

final_junctions <- final_junctions[order(final_junctions$id), ]

final_junctions <- final_junctions[, -c(1:95)]

rownames(final_junctions) <- final_junctions[, 1]
final_junctions <- final_junctions[, -1]
final_junctions <- final_junctions[, c(1:94)]
colnames(final_junctions)<-gsub(".y","",colnames(final_junctions))

#8. Append a TCGA Header Row to Retain Format
my_header <- rep(c('raw_counts'), each = 94)
final_junctions <- rbind(my_header, final_junctions)
rownames(final_junctions)[rownames(final_junctions) == '1'] <- "junction"
colnames(final_junctions) <- junc_original_sample_names

write.table(final_junctions, file = 'TCGA_HNSC_junctions.txt', sep = '\t', quote = FALSE, col.names = NA)

#9. Manually add a row header named "Hybridization REF" to the first column

#10. Use Genomic Ranges to find which genes to retain in the RSEM file. If a gene maps to multiple entrez ids, just the first id is retained
# create GenomicRanges object for junctions
detach("package:dplyr")
library('TxDb.Hsapiens.UCSC.hg19.knownGene')
library('org.Hs.eg.db')
chr <- vapply(strsplit(row.names(junc.RPM),split=":"), function(x){x[[1]]})
start <- as.numeric(vapply(strsplit(row.names(junc.RPM),split="[:-]"),
                           function(x){x[[2]]}))
end <- as.numeric(vapply(strsplit(row.names(junc.RPM),split="[:-]"),
                         function(x){x[[3]]}))


geneAnnot <- GRanges(seqnames=Rle(chr),
                     IRanges(start=start, end=end))
names(geneAnnot) <- row.names(junc.RPM)

geneAnnotAll <- GRanges(seqnames=Rle(chr),
                        IRanges(start=start, end=end))
names(geneAnnotAll) <- row.names(junc.RPM)

# get GenomicRanges object with genes for whole genome
gn <- genes(get('TxDb.Hsapiens.UCSC.hg19.knownGene'))

gSymbol <- select(get('org.Hs.eg.db'),keys=as.character(gn$gene_id),
                  columns=c('SYMBOL'),keytype='ENTREZID')
gn$SYMBOL <- gSymbol$SYMBOL
gn$ENTREZID <- gSymbol$ENTREZID
rm(gSymbol, chr, end, start)
gc()

# find symbols and ENTREZID for our junctions
overlap <- findOverlaps(geneAnnot,gn)

geneSYMBOLS <- tapply(gn$SYMBOL[subjectHits(overlap)],
                      queryHits(overlap),paste,collapse=';')

# add to genome ranges object
geneAnnot$SYMBOL <- NA
geneAnnot$SYMBOL[as.numeric(names(geneSYMBOLS))] <- geneSYMBOLS

geneENTREZID <- tapply(gn$ENTREZID[subjectHits(overlap)],
                       queryHits(overlap),paste,collapse=';')

geneAnnot$ENTREZID <- NA
geneAnnot$ENTREZID[as.numeric(names(geneENTREZID))] <- geneENTREZID

entrez_ids_to_keep <- vapply(strsplit(geneAnnot$ENTREZID, ";"), function(x){x[1]})
entrez_ids_to_keep <- unique(entrez_ids_to_keep)
entrez_ids_to_keep <- as.data.frame(entrez_ids_to_keep)
entrez_ids_to_keep <- na.omit(entrez_ids_to_keep)
rownames(entrez_ids_to_keep) <- entrez_ids_to_keep$entrez_ids_to_keep

#11. Map Entrez Ids to original RSEM file
rsem_with_all_genes$Hybridization_REF <- rownames(rsem_with_all_genes)
rsem_with_all_genes <- rsem_with_all_genes[-1, ]
rownames(rsem_with_all_genes) <- vapply(strsplit(row.names(rsem_with_all_genes), split ='\\|'), function(x){x[2]})

final_rsem <- merge(entrez_ids_to_keep, rsem_with_all_genes, by = 'row.names')
rownames(final_rsem) <- final_rsem$Hybridization_REF
final_rsem <- final_rsem[, -c(97)]
final_rsem <- final_rsem[, -c(1:2)]
final_rsem <- final_rsem[order(row.names(final_rsem)), ]

my_rsem_header <- rep(c('normalized_count'), each = 94)
final_rsem <- rbind(my_rsem_header, final_rsem)
rownames(final_rsem)[rownames(final_rsem) == '1'] <- "gene_id"

write.table(final_rsem, file = 'TCGA_HNSC_genes_normalized.txt', sep = '\t', quote = FALSE, col.names = NA)

#11. Manually add a row header named "Hybridization REF" to the first column

#12. Create rawcounts file that contains the total number rawcounts by summing the rawcounts for each gene in each sample in the full_HNSC_raw_counts_unc.txt file.
final_rawcounts <- as.data.frame(colSums(rawcounts))
final_rawcounts <- t(final_rawcounts)
rownames(final_rawcounts) <- 'total'
write.table(final_rawcounts, file = 'Total_Rawcounts.txt', sep = '\t', quote = FALSE, col.names = NA)

#13. Manually add a row header named "HYBRIDIZATION R" to the first column

#14. Create Junctions file for the regular OutSplice function by removing the header column and strand information from the junctions. Sample names here must match those in the rawcounts file.
all.junc <- read.table(file="TCGA_HNSC_junctions.txt", sep='\t', header=T, stringsAsFactors = F)

all.junc<-all.junc[-1,]
#remove header; rename row names and junctions

all.samples<-colnames(all.junc)
all.samples<-substr(all.samples, 1, 15)
all.samples<-gsub('\\.', '-', all.samples)
junction.names<-all.junc[,1]
#remove duplicates
all.junc<-all.junc[!duplicated(junction.names),]

junction.names<-all.junc[,1]
j<-paste0(vapply(strsplit(junction.names,split=":"), function(x){x[[1]]}), ":", vapply(strsplit(junction.names,split=":"), function(x){x[[2]]}), "-",vapply(strsplit(junction.names,split=":"), function(x){x[[4]]}))

rownames(all.junc)<-j
colnames(all.junc)<-all.samples

all.junc <- all.junc[,-1]

write.table(all.junc, file = 'HNSC_junctions.txt', sep = '\t', quote = FALSE, col.names = NA)

#15. Create normalized genes file for the regular OutSplice function by removing the header column. Sample names here must match those in the rawcounts file. Gene names must also be removed.
all.RSEM <- read.table(file='TCGA_HNSC_genes_normalized.txt', header=T, row.names=1, sep="\t")

all.RSEM <- all.RSEM[-1,]

expression.samples<-substr(colnames(all.RSEM), 1, 15)
expression.samples<-gsub('\\.', '-', expression.samples)
colnames(all.RSEM)<-expression.samples

rownames(all.RSEM) <- vapply(strsplit(row.names(all.RSEM), split ='\\|'), function(x){x[2]})

write.table(all.RSEM, file = 'HNSC_genes_normalized.txt', sep = '\t', quote = FALSE, col.names = NA)

#16. Same as above, manually add Hybridization REF as a header to the first columns in both the junctions and genes normalized files.

#17. The file HNSC_pheno_table.txt file was created by taking the 50 Tumor and 44 Normal Samples listed in the rawcounts vector above and labeling them as T for Tumors and F for Normals. Tumor and Normals were identified based on the TCGA labelling code at the end of the sample names: "01" for Tumor, and "11" for Normal.

---
title: "OutSplice"
author: 
- "Joseph Bendik"
- "Sandhya Kalavacherla"
- "Michael Considine"
- "Bahman Afsari"
- "Michael F. Ochs"
- "Joseph Califano"
- "Daria A. Gaykalova"
- "Elana Fertig" 
- "Theresa Guo"
package: "OutSplice"
output: 
    BiocStyle::html_document:
      toc: true
      toc_depth: 2
vignette: >
  %\VignetteIndexEntry{Find Splicing Outliers in Tumor Samples with OutSplice}
  %\VignetteEncoding{UTF-8}  
  %\VignetteEngine{knitr::rmarkdown}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
```

# Introduction

`r Biocpkg("OutSplice")` is a package that identifies aberrant splicing events in tumor samples when compared to normal samples using outlier statistics to better characterize sporadic events occurring in heterogenous cancer samples. Events are classified as skipping, insertion, or deletion events. Additionally, outlier expression of each splicing event is called per sample allowing for evaluation of splicing burden of individual samples. This package is specifically designed to analyze RNA sequencing data provided by the user; additional functions have also been added for direct analysis from the Cancer Genome Atlas (TCGA). Packages in Bioconductor, such as the `r Biocpkg("psichomics")` package, perform similar analyses on TCGA or user-generated data, however they are not specifically designed to identify cancer specific events. Because of the heterogeneity of tumors in the context of cancer biology, outlier statistics rather than mean comparisons are used to identify aberrant events, where outliers are classified on a per sample basis; this allows the algorithm to discern splicing events with outlier expression that may occur within a subset of tumor samples when compared to normal conditions. Therefore, this package generates a matrix of splicing outliers, which are associated with splice junctions that are either significantly over or under-expressed compared to the distribution of expression in normal tissue. The `r Biocpkg("FRASER")` package also offers functionality to determine splicing outliers, however, `r Biocpkg("OutSplice")` utilizes a rank sum outlier approach instead of a beta binomial model. This allows for users to eliminate less biologically relevant events by setting a minimum level of event expression. Additionally, `r Biocpkg("OutSplice")` has an easy to use work-flow that makes it accessible for researchers of varying experience with bioinformatics tools. With `r Biocpkg("OutSplice")`, the junction normalization, filtering, outlier calling, and statistical analysis are done in one function call, simplifying this process for the user. `r Biocpkg("OutSplice")` is also capable of automatically calculating the splicing burden in each of the user’s samples and will provide waterfall plots of expression to help visualize individual splicing events. Overall, this package is novel in that it determines differential splicing burdens between tumors and normal samples and characterizes the nature of splicing outliers in a quick and user friendly fashion.

## Functionality

The main functions of `r Biocpkg("OutSplice")` achieve the following for either user 
provided data or data provided from the TCGA.

1. Junction normalization
2. Outlier analysis
3. Determination of a junctional outlier as a skipping, insertion, or deletion
4. Calculation of splicing burden
5. Plotting expression levels

## Minimum required packages

`r Biocpkg("OutSplice")` will import the below packages and their dependencies so please ensure they are installed 
before using the software:

1. AnnotationDbi
2. GenomicRanges
3. GenomicFeatures
4. IRanges
5. org.Hs.eg.db
6. Repitools
7. TxDb.Hsapiens.UCSC.hg19.knownGene
8. TxDb.Hsapiens.UCSC.hg38.knownGene
9. S4Vectors

## Installation from Bioconductor
The `r Biocpkg("OutSplice")` package is available at https://bioconductor.org and can be 
installed via BiocManager::install:

```{r, echo = FALSE, eval=FALSE}
if (!require("BiocManager")) {
    install.packages("BiocManager")
}
BiocManager::install("OutSplice")
```

A package only needs to be installed once. Load the package into an R session with:

```{r, message=FALSE}
library(OutSplice)
```

# Inputs

## outspliceAnalysis/outspliceTCGA

Full Sample data for `r Biocpkg("OutSplice")` can be downloaded from The Cancer Genome Atlas (TCGA).

The outspliceAnalysis function has 4 required inputs and 13 optional Inputs.
The outspliceTCGA function has 3 required inputs and 9 optional Inputs and 
should only be used if the data is in TCGA format.

In the below examples we run outspliceAnalysis and outspliceTCGA on a subset of Head 
and Neck squamous cell carcinoma data obtained from The Broad Institute TCGA 
GDAC Firehose database.

```{r, results="hide", warning=FALSE, messages = FALSE}
junction <- system.file("extdata", "HNSC_junctions.txt.gz", package = "OutSplice")
gene_expr <- system.file("extdata", "HNSC_genes_normalized.txt.gz", package = "OutSplice")
rawcounts <- system.file("extdata", "Total_Rawcounts.txt", package = "OutSplice")
sample_labels <- system.file("extdata", "HNSC_pheno_table.txt", package = "OutSplice")
output_file_prefix <- "OutSplice_Example"
TxDb_hg19 <- "TxDb.Hsapiens.UCSC.hg19.knownGene"
dir <- paste0(tempdir(), "/")
message("Output is located at: ", dir)

results <- outspliceAnalysis(junction, gene_expr, rawcounts, sample_labels, saveOutput = TRUE, output_file_prefix, dir, filterSex = TRUE, annotation = "org.Hs.eg.db", TxDb = TxDb_hg19, offsets_value = 0.00001, correction_setting = "fdr", p_value = 0.05)
```

```{r, results="hide", warning=FALSE, messages = FALSE}
junction <- system.file("extdata", "TCGA_HNSC_junctions.txt.gz", package = "OutSplice")
gene_expr <- system.file("extdata", "TCGA_HNSC_genes_normalized.txt.gz", package = "OutSplice")
rawcounts <- system.file("extdata", "Total_Rawcounts.txt", package = "OutSplice")
output_file_prefix <- "TCGA_OutSplice_Example"
dir <- paste0(tempdir(), "/")
message("Output is located at: ", dir)

results_TCGA <- outspliceTCGA(junction, gene_expr, rawcounts, saveOutput = TRUE, output_file_prefix, dir, filterSex = TRUE, annotation = "org.Hs.eg.db", TxDb = "TxDb.Hsapiens.UCSC.hg19.knownGene", offsets_value = 0.00001, correction_setting = "fdr", p_value = 0.05)
```
  
  -junction: filepath to a matrix of junction raw read counts
  
  -gene_expr: filepath to a matrix of normalized gene expression data. RSEM quartile normalized data is recommended.
  
  -rawcounts: filepath to a matrix of raw read counts for each gene. Can either be per gene, or a summed total for each sample.
  
  -sample_labels: filepath to a matrix of phenotypes (in Section 2.2)
  
  -saveOutput: saves results output to a user specified directory. Default is FALSE [OPTIONAL]
  
  -output_file_prefix: user defined string for what the prefix of the output file should be named. Default is NULL [OPTIONAL]
  
  -dir: string containing the desired output path. Ex) "~/my_outsplice_output/". Default is NULL [OPTIONAL]
  
  -filtersex: ignores sex chromosomes when generating results. Default is TRUE [OPTIONAL]
  
  -annotation: the bioconductor package containing the annotations to use. Uses the human genome by default (in Section 3.4) [OPTIONAL]
  
  -TxDb: the bioconductor package containing the transcript annotations to use. The outspliceAnalysis function uses the hg38 genome by default, and outspliceTCGA uses hg19 by default (in Section 3.4) [OPTIONAL]
  
  -offsets_value: the normalized junction expression threshold. Uses 0.00001 by Default (in Section 3.6) [OPTIONAL]
  
  -correction_setting: the correction value to be used for p-value adjustment during Fisher analyses. The available options are: "holm", "hochberg", "hommel", "bonferroni", "BH", "BY", "fdr", and "none". Uses 'fdr' by Default. [OPTIONAL]
  
  -p_value: the significance threshold to use during Fisher analyses. Uses 0.05 by default. [OPTIONAL]
  
  -use_junc_col: an integer indicating which column in the junction matrix contains the junction regions in your matricies. Uses the first column (1) by default. outSpliceAnalysis only. [OPTIONAL]
  
  -use_gene_col: which column in the gene_expr matrix contains the entrez ids of your genes. Uses the first column (1) by default. outSpliceAnalysis only. [OPTIONAL]
  
  -use_rc_col: which column in the rawcounts matrix contains the row names. Uses the first column (1) by default. outSpliceAnalysis only. [OPTIONAL]
  
  -use_labels_col: which column in the sample_labels matrix contains the sample names. Uses the first column (1) by default. outSpliceAnalysis only. [OPTIONAL]

This algorithm is compatible with any organism provided the genome object, 
genome wide annotation, and transcript annotations exist as packages on Bioconductor.

## Phenotype matrix 

If using the outspliceAnalysis function, users must provide a phenotype matrix, 
designating which samples in the junction file belong to the tumor group 
(labeled as "T") and the normal group (labeled as "F"). Please ensure the 
matrix file contains a header row with the first column designating the sample 
names, and the second column designating the phenotype. If using TCGA data, 
the two phenotypes are "tumor" and "normal." outspliceTCGA can automatically 
infer the phenotype of TCGA data using the sample names. Only if the phenotype 
matrix has more than 10 control samples, and more than 1 tumor sample, the program proceeds. 

## plotJunctionData

After running outspliceAnalysis or outspliceTCGA, the user can create plots of specified
junctions using the plotJunctionData function.

The function plotJunctionData has 1 required input and 10 optional inputs

In the below example we can plot the expression levels for a "skipping" junction
event on the ECM1 gene based on our example data from the TCGA.

```{r, results="hide", warning=FALSE, messages=FALSE}
data_file <- system.file("extdata", "OutSplice_Example_2023-01-06.RDa", package = "OutSplice")
ecm1_junc <- "chr1:150483674-150483933"
pdf <- "ecm1_expression.pdf"
pdf_output <- paste0(tempdir(), "/", pdf)
message("Output is located at: ", pdf_output)

plotJunctionData(data_file, NUMBER = 1, junctions = ecm1_junc, tail = NULL, p_value = 0.05, GENE = FALSE, SYMBOL = NULL, makepdf = TRUE, pdffile = pdf_output, tumcol = "red", normcol = "blue")
```

  -data_file: filepath to an R Data file containing output from the outspliceAnalysis or outspliceTCGA functions.

  -NUMBER: number of junctions to plot.  This can be top number of junctions (over or under expressed), or can be specific junctions in a list.  Default is 1 [OPTIONAL]

 -junctions: you can input the specific junction you want to graph (or vector of junctions). Default is NULL [OPTIONAL]

 -tail: you can specify if you want top over or under expressed with tail='RIGHT' for junctions overexpressed in tumors, or tail='LEFT' for junctions underexpressed in tumors.  Default is NULL [OPTIONAL]

 -p_value: p-value threshold to use when plotting the top over or under-expressed junctions with "tail". Default is 0.05 [OPTIONAL]

 -GENE: Pick junctions based on a specific gene. TRUE means you will pick all the junctions mapping to a certain gene.  FALSE means you do not pick based on the gene. Default is False. [OPTIONAL]

 -SYMBOL: HGNC SYMBOL of gene you want to graph [OPTIONAL]

 -makepdf: Save graphs to a pdf?  Default is no/FALSE [OPTIONAL]

 -pdffile: if you want to save to a pdf, you will need to write the file path [OPTIONAL when makepdf = F]

 -tumcol: color for tumors on graph. Default is red [OPTIONAL]

 -normcol: color for normals on graph. Default is blue [OPTIONAL]

# Methodology

The below sections describe the processes used in the above functions.

## Junction RPM normalization

The program automatically normalizes the junction counts by dividing the 
junction counts by the total raw counts and then dividing each count by 10^6 
to generate RPM junction data.

## OGSA initial filtering

The dotheogsa function from the Bioconductor package OGSA is sourced to remove 
junctions that may not be biologically relevant due to low expression or that have any difference between tumor and normal. 
In this package, we set a 0.1 RPM expression threshold for pre-filtering. 

## OGSA outlier analysis

The dotheogsa function is again employed to determine splicing events as 
outliers, which are defined as any normalized junctions that are two standard 
deviations above or below the median of the normal distribution. A Fisher exact 
test is used to determine which junctions are significantly over or under 
expressed in tumors compared to the normal samples.

## Genomic references

The Bioconductor GenomicRanges packages are used to assign each junction to a 
known gene. The user has the option in the main function to input which genome 
and its associated Bioconductor packages to use as the reference. These Bioconductor 
packages should include the genome object, annotations, and transcript annotations.

Ex) For mouse genomes aligned to mm39, install and load: 
`r Biocpkg("Mus.musculus")` (genome object), `r Biocpkg("org.Mm.eg.db")` (annotations), 
and `r Biocpkg("TxDb.Mmusculus.UCSC.mm39.refGene")` (transcript annotations) using the library() function. Then, when using the `r Biocpkg("OutSplice")` functions, specify `r Biocpkg("org.Mm.eg.db")` for the annotation argument, 
and `r Biocpkg("TxDb.Mmusculus.UCSC.mm39.refGene")` for the TxDb argument.

This process will also work for any genome provided the correct annotation 
package, its corresponding transcript annotation package, and their dependencies 
from Bioconductor are provided and loaded.

Using this genomic assignment, the dotheogsa function determines insertion, skipping, or deletion events based on the following criteria:

insertion: junction that starts outside a known exon

skipping: junction that skips over a known exon

deletion: junction that is inside a known exon but not as its start or end

## Junction expression normalization

Junction expression is normalized based on its corresponding gene expression 
from the gene_expr input. This is achieved by dividing the junction RPM data by the 
normalized gene expression counts from a junction's corresponding gene. If a junction is aligned
to more than one gene, then the gene with the lower entrez id will be the one selected for the normalization.

## Filter by expression via offsets

Offsets, which the user can specify, sets a minimum value relative to the normal
samples in order to call a junction an outlier. The goal is to remove data with 
low expression that may not be biologically relevant. In this example example, an 
outlier junction must have a normalized expression greater than 0.00001 in 
order to be called an outlier. Any outliers with expressions below this value 
are too low to be relevant for the analysis in this example.

## Splice Burden Calculation

Sums the number of splicing events in each sample that were marked as a TRUE 
outlier for both over-expressed and under-expressed events. The total number of
outliers is then calculated as the sum of the over and under-expressed outliers.

## Junction Plotting

Creates bar and waterfall plots of junction expression in both the tumor and
normal samples. The data for these plots comes from the raw junction input, the
gene expression values to reflect overall gene expression, and the junction
expression normalized by gene expression.

# Outputs

## outSpliceAnalysis/outSpliceTCGA

Returns a list and, if specified, an R data file and tab deliminated text files with the following data:

  -ASE.type: significant junction events labeled by type (skipping, insertion, or deletion)
  
  -FisherAnalyses: Data Frame of junction events containing the number of under/over-expressed outliers in the tumor group (Num_UE_Outliers/Num_OE_Outliers), the Fisher p-value for under/over-expressed events (FisherP1/FisherP2), and a ranking of the under/over expressed events (UE_Rank/OE_Rank)
  
  -geneAnnotations: object containing gene names corresponding to each junction region
  
  junc.Outliers: list containing the logical matrices TumorOverExpression and TumorUnderExpression. “True” indicates an over-expressed event in TumorOverExpression, or an under-expressed event in TumorUnderExpression.
  
  -junc.RPM: junction counts in reads per million following a division of the junction counts input by the total rawcounts for each sample
  
  -junc.RPM.norm: junction counts normalized by each event's total gene expression value
  
  -gene_expr: gene expression values for each junction event
  
  -splice_burden: matrix containing the number of Fisher-P significant over-expressed, under-expressed, and total number of outliers per sample
  
  -NORM.gene_expr.norm: Median of junction data normalized by gene expression for normal samples only (Used for Junction Plotting Only)
  
  -pheno: Phenotypes of Samples (Tumor or Normal)
  
  -pvalues: Junction Fisher P-values
  
If file output was specified, the files are:

  -Data File: <output_file_prefix>_<date>.RDa

  -ASE.type: event_types.txt
  
  -FisherAnalyses: FisherAnalyses.txt
  
  -geneAnnotations: gene_annotations.txt
  
  -junc.Outliers: TumorOverExpression.txt, TumorUnderExpression.txt
  
  -splice_burden: splice_burden.txt
  
## plotJunctionData

Outputs junction expression plots of user specified junctions as defined in 
Section 3.8. Plots can be saved to a user defined pdf file.
  
# References

Broad Institute TCGA Genome Data Analysis Center (2016): Firehose stddata__2016_01_28 run. Broad Institute of MIT and Harvard. doi:10.7908/C11G0KM9

Cancer Genome Atlas Network. Comprehensive genomic characterization of head and neck squamous cell carcinomas. Nature. 2015 Jan 29;517(7536):576-82. doi: 10.1038/nature14129. PMID: 25631445; PMCID: PMC4311405.

Guo T, Sakai A, Afsari B, Considine M, Danilova L, Favorov AV, Yegnasubramanian S, Kelley DZ, Flam E, Ha PK, Khan Z, Wheelan SJ, Gutkind JS, Fertig EJ, Gaykalova DA, Califano J. A Novel Functional Splice Variant of AKT3 Defined by Analysis of Alternative Splice Expression in HPV-Positive Oropharyngeal Cancers. Cancer Res. 2017 Oct 1;77(19):5248-5258. doi: 10.1158/0008-5472.CAN-16-3106. Epub 2017 Jul 21. PMID: 28733453; PMCID: PMC6042297.

Liu C, Guo T, Sakai A, Ren S, Fukusumi T, Ando M, Sadat S, Saito Y, Califano JA. A novel splice variant of LOXL2 promotes progression of human papillomavirus-negative head and neck squamous cell carcinoma. Cancer. 2020 Feb 15;126(4):737-748. doi: 10.1002/cncr.32610. Epub 2019 Nov 13. PMID: 31721164.

Liu C, Guo T, Xu G, Sakai A, Ren S, Fukusumi T, Ando M, Sadat S, Saito Y, Khan Z, Fisch KM, Califano J. Characterization of Alternative Splicing Events in HPV-Negative Head and Neck Squamous Cell Carcinoma Identifies an Oncogenic DOCK5 Variant. Clin Cancer Res. 2018 Oct 15;24(20):5123-5132. doi: 10.1158/1078-0432.CCR-18-0752. Epub 2018 Jun 26. PMID: 29945995; PMCID: PMC6440699.

M. F. Ochs, J. E. Farrar, M. Considine, Y. Wei, S. Meshinchi, and R. J. 
Arceci. Outlier analysis and top scoring pair for integrated data analysis and 
biomarker discovery. IEEE/ACM Trans Comput Biol Bioinform, 11: 520-32, 2014. PMCID: PMC4156935

# Session Info

```{r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/OutSpliceOverview.R
\name{OutSplice}
\alias{OutSplice}
\title{OutSplice package overview}
\value{
Please see the man pages for each function.
}
\description{
An easy to use tool that can compare splicing events in tumor and normal tissue
samples using either a user generated matrix, or data from The Cancer Genome Atlas (TCGA).
This package generates a matrix of splicing outliers that are significantly
over or underexpressed in tumors samples compared to normal denoted by chromosome location.
The package also will calculate the splicing burden in each tumor, characterize
the types of splicing events that occur, and allows the user to create waterfall
plots of event expression.
}
\details{
Below are the available functions provided by OutSplice:
\itemize{
    \item \code{\link{outspliceAnalysis}}
    \item \code{\link{outspliceTCGA}}
    \item \code{\link{plotJunctionData}}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TCGA_SplicingOutliers_Function.R
\name{outspliceTCGA}
\alias{outspliceTCGA}
\title{Alternative Splicing Analysis for TCGA Data}
\usage{
outspliceTCGA(
  junction,
  gene_expr,
  rawcounts,
  saveOutput = FALSE,
  output_file_prefix = NULL,
  dir = NULL,
  filterSex = TRUE,
  annotation = "org.Hs.eg.db",
  TxDb = "TxDb.Hsapiens.UCSC.hg19.knownGene",
  offsets_value = 1e-05,
  correction_setting = "fdr",
  p_value = 0.05
)
}
\arguments{
\item{junction}{A character string giving the path to a tab separated text file with raw junction counts.}

\item{gene_expr}{A character string giving the path to a tab separated file with normalized gene expression data.}

\item{rawcounts}{A character string giving the path to a tab separated text file with the reads per million counts for each sample.}

\item{saveOutput}{A boolean representing whether or not to save the results to an R data file and tab separated files. Default is FALSE. Optional.}

\item{output_file_prefix}{A character string giving the name of the prefix the user would like to use for the output data file. Default is NULL. Optional.}

\item{dir}{A character string giving the path to the directory the user would like to save output to. Default is NULL. Optional.}

\item{filterSex}{A boolean representing whether or not to include junctions found on the sex chromosomes. Default is TRUE. Optional.}

\item{annotation}{A connection or a character string giving the name of the Bioconductor library the user would like to use containing the genome wide annotation. Default is "org.Hs.eg.db". Optional.}

\item{TxDb}{A character string giving the name of the Bioconductor library the user would like to use that will expose the annotation database as a TxDb object. Default is "TxDb.Hsapiens.UCSC.hg19.knownGene". Optional.}

\item{offsets_value}{The minimum expression value needed to call an event an outlier after normalizing event expression with gene expression. Default is 0.00001 Optional.}

\item{correction_setting}{Option to designate how to correct significance. The available options are: "holm", "hochberg", "hommel", "bonferroni", "BH", "BY", "fdr", and "none". Default is "fdr". Optional.}

\item{p_value}{Set the alpha value for the significance threshold. Default is 0.05. Optional.}
}
\value{
A list containing the below data.
\itemize{
    \item FisherAnalyses: Data Frame of junction events containing the number of under/over-expressed outliers in the tumor group (Num_UE_Outliers/Num_OE_Outliers), the Fisher p-value for under/over-expressed events (FisherP1/FisherP2), and a ranking of the under/over expressed events (UE_Rank/OE_Rank). This function will also output tab sepaerated text files and an R data file with the following:
    \item ASE.type: significant junction events labeled by type (skipping, insertion, or deletion)
    \item geneAnnotations: object containing gene names corresponding to each junction region
    \item junc.Outliers: list containing the logical matrices TumorOverExpression and TumorUnderExpression. "True" indicates an over-expressed event in TumorOverExpression, or an under-expressed event in TumorUnderExpression.
    \item junc.RPM: junction counts in reads per million following a division of the junction counts input by the total rawcounts for each sample
    \item junc.RPM.norm: junction counts normalized by each event's total gene expression value
    \item gene_expr: gene expression values for each junction event
    \item splice_burden: matrix containing the number of Fisher-P significant over-expressed, under-expressed, and total number of outliers per sample
    \item NORM.gene_expr.norm: Median of junction data normalized by gene expression for normal samples only (Used for Junction Plotting)
    \item pheno: Phenotypes of Samples (Tumor or Normal)
    \item pvalues: Junction Fisher P-values
}
}
\description{
Analyze differential splicing events between tumor and normal samples for TCGA formatted datasets. Examples of TCGA file formats can be viewed here (https://gdac.broadinstitute.org/)
}
\examples{
junction <- system.file("extdata", "TCGA_HNSC_junctions.txt.gz", package = "OutSplice")
gene_expr <- system.file("extdata", "TCGA_HNSC_genes_normalized.txt.gz", package = "OutSplice")
rawcounts <- system.file("extdata", "Total_Rawcounts.txt", package = "OutSplice")
output_file_prefix <- "TCGA_OutSplice_Example"
dir <- paste0(tempdir(), "/")
results_TCGA <- outspliceTCGA(junction, gene_expr, rawcounts, saveOutput = TRUE, output_file_prefix, dir, filterSex = TRUE, annotation = "org.Hs.eg.db", TxDb = "TxDb.Hsapiens.UCSC.hg19.knownGene", offsets_value = 0.00001, correction_setting = "fdr", p_value = 0.05)
message("Output is located at: ", dir)
}
\references{
Broad Institute TCGA Genome Data Analysis Center (2016): Firehose stddata__2016_01_28 run. Broad Institute of MIT and Harvard. doi:10.7908/C11G0KM9

Cancer Genome Atlas Network. Comprehensive genomic characterization of head and neck squamous cell carcinomas. Nature. 2015 Jan 29;517(7536):576-82. doi: 10.1038/nature14129. PMID: 25631445; PMCID: PMC4311405.

Guo T, Sakai A, Afsari B, Considine M, Danilova L, Favorov AV, Yegnasubramanian S, Kelley DZ, Flam E, Ha PK, Khan Z, Wheelan SJ, Gutkind JS, Fertig EJ, Gaykalova DA, Califano J. A Novel Functional Splice Variant of AKT3 Defined by Analysis of Alternative Splice Expression in HPV-Positive Oropharyngeal Cancers. Cancer Res. 2017 Oct 1;77(19):5248-5258. doi: 10.1158/0008-5472.CAN-16-3106. Epub 2017 Jul 21. PMID: 28733453; PMCID: PMC6042297.

Liu C, Guo T, Sakai A, Ren S, Fukusumi T, Ando M, Sadat S, Saito Y, Califano JA. A novel splice variant of LOXL2 promotes progression of human papillomavirus-negative head and neck squamous cell carcinoma. Cancer. 2020 Feb 15;126(4):737-748. doi: 10.1002/cncr.32610. Epub 2019 Nov 13. PMID: 31721164.

Liu C, Guo T, Xu G, Sakai A, Ren S, Fukusumi T, Ando M, Sadat S, Saito Y, Khan Z, Fisch KM, Califano J. Characterization of Alternative Splicing Events in HPV-Negative Head and Neck Squamous Cell Carcinoma Identifies an Oncogenic DOCK5 Variant. Clin Cancer Res. 2018 Oct 15;24(20):5123-5132. doi: 10.1158/1078-0432.CCR-18-0752. Epub 2018 Jun 26. PMID: 29945995; PMCID: PMC6440699.

M. F. Ochs, J. E. Farrar, M. Considine, Y. Wei, S. Meshinchi, and R. J. Arceci. Outlier analysis and top scoring pair for integrated data analysis and biomarker discovery. IEEE/ACM Trans Comput Biol Bioinform, 11: 520-32, 2014. PMCID: PMC4156935
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PlotJunctionFunction.R
\name{plotJunctionData}
\alias{plotJunctionData}
\title{Create Plots of Junction Expression}
\usage{
plotJunctionData(
  data_file,
  NUMBER = 1,
  junctions = NULL,
  tail = NULL,
  p_value = 0.05,
  GENE = FALSE,
  SYMBOL = NULL,
  makepdf = FALSE,
  pdffile = NULL,
  tumcol = "red",
  normcol = "blue"
)
}
\arguments{
\item{data_file}{An R data file containing OutSplice Output.}

\item{NUMBER}{An integer indicating the number of junctions to plot. This can be top number of junctions (over or under expressed), or can be specific junctions in a list. Default is 1.}

\item{junctions}{A vector of user specified junctions that should be plotted. Default is NULL.}

\item{tail}{A character string indicating either "RIGHT" to plot the top over expressed junctions, or "LEFT" to plot the top under expressed junctions. Default is NULL.}

\item{p_value}{Set the alpha value for the significance threshold.}

\item{GENE}{A boolean indicating whether to plot junctions by a specific gene. TRUE means you will pick all the junctions mapping to a certain gene. FALSE means you do not pick based on the gene. Default is NULL.}

\item{SYMBOL}{The HGNC gene symbol of the gene to be graphed. Default is NULL.}

\item{makepdf}{A boolean specifying whether or not to save plots to a PDF. Default is FALSE.}

\item{pdffile}{A character string giving the file path to the desired pdf. Default is NULL.}

\item{tumcol}{A character string defining the color of the tumor samples in the plots. Default is red.}

\item{normcol}{A character string defining the color of the normal samples in the plots. Default is blue.}
}
\value{
NULL. Displays or saves a pdf containing waterfall plots of junction expression.
}
\description{
Create Bar and Waterfall plots of raw junction expression, overall gene expression, and junction expression normalized by gene expression for splicing events found by OutSplice.
}
\examples{
data_file <- system.file("extdata", "OutSplice_Example_2023-01-06.RDa", package = "OutSplice")
ecm1_junc <- "chr1:150483674-150483933"
pdf <- "ecm1_expression.pdf"
pdf_output <- paste0(tempdir(), "/", pdf)
plotJunctionData(data_file, NUMBER = 1, junctions = ecm1_junc, tail = NULL, p_value = 0.05, GENE = FALSE, SYMBOL = NULL, makepdf = TRUE, pdffile = pdf_output, tumcol = "red", normcol = "blue")
message("Output is located at: ", pdf_output)
}
\references{
Broad Institute TCGA Genome Data Analysis Center (2016): Firehose stddata__2016_01_28 run. Broad Institute of MIT and Harvard. doi:10.7908/C11G0KM9

Cancer Genome Atlas Network. Comprehensive genomic characterization of head and neck squamous cell carcinomas. Nature. 2015 Jan 29;517(7536):576-82. doi: 10.1038/nature14129. PMID: 25631445; PMCID: PMC4311405.

Guo T, Sakai A, Afsari B, Considine M, Danilova L, Favorov AV, Yegnasubramanian S, Kelley DZ, Flam E, Ha PK, Khan Z, Wheelan SJ, Gutkind JS, Fertig EJ, Gaykalova DA, Califano J. A Novel Functional Splice Variant of AKT3 Defined by Analysis of Alternative Splice Expression in HPV-Positive Oropharyngeal Cancers. Cancer Res. 2017 Oct 1;77(19):5248-5258. doi: 10.1158/0008-5472.CAN-16-3106. Epub 2017 Jul 21. PMID: 28733453; PMCID: PMC6042297.

Liu C, Guo T, Sakai A, Ren S, Fukusumi T, Ando M, Sadat S, Saito Y, Califano JA. A novel splice variant of LOXL2 promotes progression of human papillomavirus-negative head and neck squamous cell carcinoma. Cancer. 2020 Feb 15;126(4):737-748. doi: 10.1002/cncr.32610. Epub 2019 Nov 13. PMID: 31721164.

Liu C, Guo T, Xu G, Sakai A, Ren S, Fukusumi T, Ando M, Sadat S, Saito Y, Khan Z, Fisch KM, Califano J. Characterization of Alternative Splicing Events in HPV-Negative Head and Neck Squamous Cell Carcinoma Identifies an Oncogenic DOCK5 Variant. Clin Cancer Res. 2018 Oct 15;24(20):5123-5132. doi: 10.1158/1078-0432.CCR-18-0752. Epub 2018 Jun 26. PMID: 29945995; PMCID: PMC6440699.

M. F. Ochs, J. E. Farrar, M. Considine, Y. Wei, S. Meshinchi, and R. J. Arceci. Outlier analysis and top scoring pair for integrated data analysis and biomarker discovery. IEEE/ACM Trans Comput Biol Bioinform, 11: 520-32, 2014. PMCID: PMC4156935
}
